/[gentoo-x86]/eclass/python.eclass
Gentoo

Diff of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.87 Revision 1.156
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.87 2010/02/02 18:55:00 arfrever Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.156 2012/08/16 07:46:15 patrick Exp $
4 4
5# @ECLASS: python.eclass 5# @ECLASS: python.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# python@gentoo.org 7# Gentoo Python Project <python@gentoo.org>
8# @BLURB: A utility eclass that should be inherited by anything that deals with Python or Python modules. 8# @BLURB: Eclass for Python packages
9# @DESCRIPTION: 9# @DESCRIPTION:
10# Some useful functions for dealing with Python. 10# The python eclass contains miscellaneous, useful functions for Python packages.
11 11
12# Must call inherit before EXPORT_FUNCTIONS to avoid QA warning.
13if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
12inherit multilib 14 inherit multilib
15fi
13 16
17# Export pkg_setup every time to avoid issues with eclass inheritance order.
18if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
19 EXPORT_FUNCTIONS pkg_setup
20fi
21
22# Avoid processing this eclass more than once.
23if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
24_PYTHON_ECLASS_INHERITED="1"
25
14if ! has "${EAPI:-0}" 0 1 2 3; then 26if ! has "${EAPI:-0}" 0 1 2 3 4; then
15 die "API of python.eclass in EAPI=\"${EAPI}\" not established" 27 die "API of python.eclass in EAPI=\"${EAPI}\" not established"
16fi 28fi
17 29
18_PYTHON2_SUPPORTED_VERSIONS=(2.4 2.5 2.6 2.7) 30_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7)
19_PYTHON3_SUPPORTED_VERSIONS=(3.0 3.1 3.2) 31_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.1 3.2)
32_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython)
33_PYPY_GLOBALLY_SUPPORTED_ABIS=(2.7-pypy-1.7 2.7-pypy-1.8 2.7-pypy-1.9)
34_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]} ${_PYPY_GLOBALLY_SUPPORTED_ABIS[@]})
35
36# ================================================================================================
37# ===================================== HANDLING OF METADATA =====================================
38# ================================================================================================
39
40_PYTHON_ABI_PATTERN_REGEX="([[:alnum:]]|\.|-|\*|\[|\])+"
41
42_python_check_python_abi_matching() {
43 local pattern patterns patterns_list="0" PYTHON_ABI
44
45 while (($#)); do
46 case "$1" in
47 --patterns-list)
48 patterns_list="1"
49 ;;
50 --)
51 shift
52 break
53 ;;
54 -*)
55 die "${FUNCNAME}(): Unrecognized option '$1'"
56 ;;
57 *)
58 break
59 ;;
60 esac
61 shift
62 done
63
64 if [[ "$#" -ne 2 ]]; then
65 die "${FUNCNAME}() requires 2 arguments"
66 fi
67
68 PYTHON_ABI="$1"
69
70 if [[ "${patterns_list}" == "0" ]]; then
71 pattern="$2"
72
73 if [[ "${pattern}" == *"-cpython" ]]; then
74 [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ && "${PYTHON_ABI}" == ${pattern%-cpython} ]]
75 elif [[ "${pattern}" == *"-jython" ]]; then
76 [[ "${PYTHON_ABI}" == ${pattern} ]]
77 elif [[ "${pattern}" == *"-pypy-"* ]]; then
78 [[ "${PYTHON_ABI}" == ${pattern} ]]
79 else
80 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
81 [[ "${PYTHON_ABI}" == ${pattern} ]]
82 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
83 [[ "${PYTHON_ABI%-jython}" == ${pattern} ]]
84 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-pypy-[[:digit:]]+\.[[:digit:]]+$ ]]; then
85 [[ "${PYTHON_ABI%-pypy-*}" == ${pattern} ]]
86 else
87 die "${FUNCNAME}(): Unrecognized Python ABI '${PYTHON_ABI}'"
88 fi
89 fi
90 else
91 patterns="${2// /$'\n'}"
92
93 while read pattern; do
94 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then
95 return 0
96 fi
97 done <<< "${patterns}"
98
99 return 1
100 fi
101}
102
103_python_implementation() {
104 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
105 return 0
106 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
107 return 0
108 elif [[ "${CATEGORY}/${PN}" == "dev-python/pypy" ]]; then
109 return 0
110 else
111 return 1
112 fi
113}
114
115_python_package_supporting_installation_for_multiple_python_abis() {
116 if has "${EAPI:-0}" 0 1 2 3 4; then
117 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
118 return 0
119 else
120 return 1
121 fi
122 else
123 die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
124 fi
125}
20 126
21# @ECLASS-VARIABLE: PYTHON_DEPEND 127# @ECLASS-VARIABLE: PYTHON_DEPEND
22# @DESCRIPTION: 128# @DESCRIPTION:
23# Specification of dependency on dev-lang/python. 129# Specification of dependency on dev-lang/python.
24# Syntax: 130# Syntax:
26# version_components_group: <major_version[:[minimal_version][:maximal_version]]> 132# version_components_group: <major_version[:[minimal_version][:maximal_version]]>
27# major_version: <2|3|*> 133# major_version: <2|3|*>
28# minimal_version: <minimal_major_version.minimal_minor_version> 134# minimal_version: <minimal_major_version.minimal_minor_version>
29# maximal_version: <maximal_major_version.maximal_minor_version> 135# maximal_version: <maximal_major_version.maximal_minor_version>
30 136
31_parse_PYTHON_DEPEND() { 137_python_parse_PYTHON_DEPEND() {
32 local accepted_version accepted_versions=() major_version maximal_version minimal_version python_all="0" python_atoms= python_maximal_version python_minimal_version python_versions=() python2="0" python2_maximal_version python2_minimal_version python3="0" python3_maximal_version python3_minimal_version USE_flag= version_components_group version_components_group_regex version_components_groups 138 local major_version maximal_version minimal_version python_all="0" python_maximal_version python_minimal_version python_versions=() python2="0" python2_maximal_version python2_minimal_version python3="0" python3_maximal_version python3_minimal_version USE_flag= version_components_group version_components_group_regex version_components_groups
33 139
34 version_components_group_regex="(2|3|\*)(:([[:digit:]]+\.[[:digit:]]+)?(:([[:digit:]]+\.[[:digit:]]+)?)?)?" 140 version_components_group_regex="(2|3|\*)(:([[:digit:]]+\.[[:digit:]]+)?(:([[:digit:]]+\.[[:digit:]]+)?)?)?"
35 version_components_groups="${PYTHON_DEPEND}" 141 version_components_groups="${PYTHON_DEPEND}"
36 142
37 if [[ "${version_components_groups}" =~ ^((\!)?[[:alnum:]_-]+\?\ )?${version_components_group_regex}(\ ${version_components_group_regex})?$ ]]; then 143 if [[ "${version_components_groups}" =~ ^((\!)?[[:alnum:]_-]+\?\ )?${version_components_group_regex}(\ ${version_components_group_regex})?$ ]]; then
59 fi 165 fi
60 fi 166 fi
61 167
62 if [[ "${major_version}" == "2" ]]; then 168 if [[ "${major_version}" == "2" ]]; then
63 python2="1" 169 python2="1"
64 python_versions=("${_PYTHON2_SUPPORTED_VERSIONS[@]}") 170 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}")
65 python2_minimal_version="${minimal_version}" 171 python2_minimal_version="${minimal_version}"
66 python2_maximal_version="${maximal_version}" 172 python2_maximal_version="${maximal_version}"
67 elif [[ "${major_version}" == "3" ]]; then 173 elif [[ "${major_version}" == "3" ]]; then
68 python3="1" 174 python3="1"
69 python_versions=("${_PYTHON3_SUPPORTED_VERSIONS[@]}") 175 python_versions=("${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
70 python3_minimal_version="${minimal_version}" 176 python3_minimal_version="${minimal_version}"
71 python3_maximal_version="${maximal_version}" 177 python3_maximal_version="${maximal_version}"
72 else 178 else
73 python_all="1" 179 python_all="1"
74 python_versions=("${_PYTHON2_SUPPORTED_VERSIONS[@]}" "${_PYTHON3_SUPPORTED_VERSIONS[@]}") 180 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
75 python_minimal_version="${minimal_version}" 181 python_minimal_version="${minimal_version}"
76 python_maximal_version="${maximal_version}" 182 python_maximal_version="${maximal_version}"
77 fi 183 fi
78 184
79 if [[ -n "${minimal_version}" ]] && ! has "${minimal_version}" "${python_versions[@]}"; then 185 if [[ -n "${minimal_version}" ]] && ! has "${minimal_version}" "${python_versions[@]}"; then
86 if [[ -n "${minimal_version}" && -n "${maximal_version}" && "${minimal_version}" > "${maximal_version}" ]]; then 192 if [[ -n "${minimal_version}" && -n "${maximal_version}" && "${minimal_version}" > "${maximal_version}" ]]; then
87 die "Invalid syntax of PYTHON_DEPEND: Minimal version '${minimal_version}' greater than maximal version '${maximal_version}'" 193 die "Invalid syntax of PYTHON_DEPEND: Minimal version '${minimal_version}' greater than maximal version '${maximal_version}'"
88 fi 194 fi
89 done <<< "${version_components_groups}" 195 done <<< "${version_components_groups}"
90 196
197 _PYTHON_ATOMS=()
198
91 _create_accepted_versions_range() { 199 _append_accepted_versions_range() {
92 local accepted_version="0" i 200 local accepted_version="0" i
93 for ((i = "${#python_versions[@]}"; i >= 0; i--)); do 201 for ((i = "${#python_versions[@]}"; i >= 0; i--)); do
94 if [[ "${python_versions[${i}]}" == "${python_maximal_version}" ]]; then 202 if [[ "${python_versions[${i}]}" == "${python_maximal_version}" ]]; then
95 accepted_version="1" 203 accepted_version="1"
96 fi 204 fi
97 if [[ "${accepted_version}" == "1" ]]; then 205 if [[ "${accepted_version}" == "1" ]]; then
98 accepted_versions+=("${python_versions[${i}]}") 206 _PYTHON_ATOMS+=("=dev-lang/python-${python_versions[${i}]}*")
99 fi 207 fi
100 if [[ "${python_versions[${i}]}" == "${python_minimal_version}" ]]; then 208 if [[ "${python_versions[${i}]}" == "${python_minimal_version}" ]]; then
101 accepted_version="0" 209 accepted_version="0"
102 fi 210 fi
103 done 211 done
104 } 212 }
105 213
106 if [[ "${python_all}" == "1" ]]; then 214 if [[ "${python_all}" == "1" ]]; then
215 if [[ -z "${python_minimal_version}" && -z "${python_maximal_version}" ]]; then
216 _PYTHON_ATOMS+=("dev-lang/python")
217 else
107 python_versions=("${_PYTHON2_SUPPORTED_VERSIONS[@]}" "${_PYTHON3_SUPPORTED_VERSIONS[@]}") 218 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
108 python_minimal_version="${python_minimal_version:-${python_versions[0]}}" 219 python_minimal_version="${python_minimal_version:-${python_versions[0]}}"
109 python_maximal_version="${python_maximal_version:-${python_versions[${#python_versions[@]}-1]}}" 220 python_maximal_version="${python_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
110 _create_accepted_versions_range 221 _append_accepted_versions_range
222 fi
111 else 223 else
112 if [[ "${python3}" == "1" ]]; then 224 if [[ "${python3}" == "1" ]]; then
225 if [[ -z "${python3_minimal_version}" && -z "${python3_maximal_version}" ]]; then
226 _PYTHON_ATOMS+=("=dev-lang/python-3*")
227 else
113 python_versions=("${_PYTHON3_SUPPORTED_VERSIONS[@]}") 228 python_versions=("${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
114 python_minimal_version="${python3_minimal_version:-${python_versions[0]}}" 229 python_minimal_version="${python3_minimal_version:-${python_versions[0]}}"
115 python_maximal_version="${python3_maximal_version:-${python_versions[${#python_versions[@]}-1]}}" 230 python_maximal_version="${python3_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
116 _create_accepted_versions_range 231 _append_accepted_versions_range
232 fi
117 fi 233 fi
118 if [[ "${python2}" == "1" ]]; then 234 if [[ "${python2}" == "1" ]]; then
235 if [[ -z "${python2_minimal_version}" && -z "${python2_maximal_version}" ]]; then
236 _PYTHON_ATOMS+=("=dev-lang/python-2*")
237 else
119 python_versions=("${_PYTHON2_SUPPORTED_VERSIONS[@]}") 238 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}")
120 python_minimal_version="${python2_minimal_version:-${python_versions[0]}}" 239 python_minimal_version="${python2_minimal_version:-${python_versions[0]}}"
121 python_maximal_version="${python2_maximal_version:-${python_versions[${#python_versions[@]}-1]}}" 240 python_maximal_version="${python2_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
122 _create_accepted_versions_range 241 _append_accepted_versions_range
123 fi 242 fi
124 fi 243 fi
244 fi
125 245
126 for accepted_version in "${accepted_versions[@]}"; do 246 unset -f _append_accepted_versions_range
127 python_atoms+="${python_atoms:+ }=dev-lang/python-${accepted_version}*"
128 done
129 247
130 _PYTHON_ATOMS="${python_atoms// /$'\n'}" 248 if [[ "${#_PYTHON_ATOMS[@]}" -gt 1 ]]; then
131 DEPEND+="${DEPEND:+ }${USE_flag}${USE_flag:+? ( }|| ( ${python_atoms} )${USE_flag:+ )}" 249 DEPEND+="${DEPEND:+ }${USE_flag}${USE_flag:+? ( }|| ( ${_PYTHON_ATOMS[@]} )${USE_flag:+ )}"
132 RDEPEND+="${RDEPEND:+ }${USE_flag}${USE_flag:+? ( }|| ( ${python_atoms} )${USE_flag:+ )}" 250 RDEPEND+="${RDEPEND:+ }${USE_flag}${USE_flag:+? ( }|| ( ${_PYTHON_ATOMS[@]} )${USE_flag:+ )}"
251 else
252 DEPEND+="${DEPEND:+ }${USE_flag}${USE_flag:+? ( }${_PYTHON_ATOMS[@]}${USE_flag:+ )}"
253 RDEPEND+="${RDEPEND:+ }${USE_flag}${USE_flag:+? ( }${_PYTHON_ATOMS[@]}${USE_flag:+ )}"
254 fi
133 else 255 else
134 die "Invalid syntax of PYTHON_DEPEND" 256 die "Invalid syntax of PYTHON_DEPEND"
135 fi 257 fi
136} 258}
137 259
260if _python_implementation; then
138DEPEND=">=app-admin/eselect-python-20090804" 261 DEPEND=">=app-admin/eselect-python-20091230"
139RDEPEND="${DEPEND}" 262 RDEPEND="${DEPEND}"
263 PDEPEND="app-admin/python-updater"
264fi
140 265
141if [[ -n "${PYTHON_DEPEND}" && -n "${NEED_PYTHON}" ]]; then
142 die "PYTHON_DEPEND and NEED_PYTHON cannot be set simultaneously"
143elif [[ -n "${PYTHON_DEPEND}" ]]; then 266if [[ -n "${PYTHON_DEPEND}" ]]; then
144 _parse_PYTHON_DEPEND 267 _python_parse_PYTHON_DEPEND
145elif [[ -n "${NEED_PYTHON}" ]]; then
146 if ! has "${EAPI:-0}" 0 1 2; then
147 eerror "Use PYTHON_DEPEND instead of NEED_PYTHON."
148 die "NEED_PYTHON cannot be used in this EAPI"
149 fi
150 _PYTHON_ATOMS=">=dev-lang/python-${NEED_PYTHON}"
151 DEPEND+="${DEPEND:+ }${_PYTHON_ATOMS}"
152 RDEPEND+="${RDEPEND:+ }${_PYTHON_ATOMS}"
153else 268else
154 _PYTHON_ATOMS="dev-lang/python" 269 _PYTHON_ATOMS=("dev-lang/python")
270fi
271unset -f _python_parse_PYTHON_DEPEND
272
273if [[ -n "${NEED_PYTHON}" ]]; then
274 eerror "Use PYTHON_DEPEND variable instead of NEED_PYTHON variable."
275 die "NEED_PYTHON variable is banned"
155fi 276fi
156 277
157# @ECLASS-VARIABLE: PYTHON_USE_WITH 278# @ECLASS-VARIABLE: PYTHON_USE_WITH
158# @DESCRIPTION: 279# @DESCRIPTION:
159# Set this to a space separated list of USE flags the Python slot in use must be built with. 280# Set this to a space separated list of USE flags the Python slot in use must be built with.
165# @ECLASS-VARIABLE: PYTHON_USE_WITH_OPT 286# @ECLASS-VARIABLE: PYTHON_USE_WITH_OPT
166# @DESCRIPTION: 287# @DESCRIPTION:
167# Set this to a name of a USE flag if you need to make either PYTHON_USE_WITH or 288# Set this to a name of a USE flag if you need to make either PYTHON_USE_WITH or
168# PYTHON_USE_WITH_OR atoms conditional under a USE flag. 289# PYTHON_USE_WITH_OR atoms conditional under a USE flag.
169 290
291if ! has "${EAPI:-0}" 0 1 && [[ -n ${PYTHON_USE_WITH} || -n ${PYTHON_USE_WITH_OR} ]]; then
292 _PYTHON_USE_WITH_ATOMS_ARRAY=()
293 if [[ -n "${PYTHON_USE_WITH}" ]]; then
294 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do
295 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${PYTHON_USE_WITH// /,}]")
296 done
297 elif [[ -n "${PYTHON_USE_WITH_OR}" ]]; then
298 for _USE_flag in ${PYTHON_USE_WITH_OR}; do
299 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do
300 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${_USE_flag}]")
301 done
302 done
303 unset _USE_flag
304 fi
305 if [[ "${#_PYTHON_USE_WITH_ATOMS_ARRAY[@]}" -gt 1 ]]; then
306 _PYTHON_USE_WITH_ATOMS="|| ( ${_PYTHON_USE_WITH_ATOMS_ARRAY[@]} )"
307 else
308 _PYTHON_USE_WITH_ATOMS="${_PYTHON_USE_WITH_ATOMS_ARRAY[@]}"
309 fi
310 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then
311 _PYTHON_USE_WITH_ATOMS="${PYTHON_USE_WITH_OPT}? ( ${_PYTHON_USE_WITH_ATOMS} )"
312 fi
313 DEPEND+="${DEPEND:+ }${_PYTHON_USE_WITH_ATOMS}"
314 RDEPEND+="${RDEPEND:+ }${_PYTHON_USE_WITH_ATOMS}"
315 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOMS _PYTHON_USE_WITH_ATOMS_ARRAY
316fi
317
318unset _PYTHON_ATOMS
319
320# ================================================================================================
321# =================================== MISCELLANEOUS FUNCTIONS ====================================
322# ================================================================================================
323
324_python_abi-specific_local_scope() {
325 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]]
326}
327
328_python_initialize_prefix_variables() {
329 if has "${EAPI:-0}" 0 1 2; then
330 if [[ -n "${ROOT}" && -z "${EROOT}" ]]; then
331 EROOT="${ROOT%/}${EPREFIX}/"
332 fi
333 if [[ -n "${D}" && -z "${ED}" ]]; then
334 ED="${D%/}${EPREFIX}/"
335 fi
336 fi
337}
338
339unset PYTHON_SANITY_CHECKS_EXECUTED PYTHON_SKIP_SANITY_CHECKS
340
341_python_initial_sanity_checks() {
342 if [[ "$(declare -p PYTHON_SANITY_CHECKS_EXECUTED 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS_EXECUTED="* || " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " && -z "${PYTHON_SKIP_SANITY_CHECKS}" ]]; then
343 # Ensure that /usr/bin/python and /usr/bin/python-config are valid.
344 if [[ "$(readlink "${EPREFIX}/usr/bin/python")" != "python-wrapper" ]]; then
345 eerror "'${EPREFIX}/usr/bin/python' is not valid symlink."
346 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
347 die "'${EPREFIX}/usr/bin/python' is not valid symlink"
348 fi
349 if [[ "$(<"${EPREFIX}/usr/bin/python-config")" != *"Gentoo python-config wrapper script"* ]]; then
350 eerror "'${EPREFIX}/usr/bin/python-config' is not valid script"
351 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
352 die "'${EPREFIX}/usr/bin/python-config' is not valid script"
353 fi
354 fi
355}
356
357_python_final_sanity_checks() {
358 if ! _python_implementation && [[ "$(declare -p PYTHON_SANITY_CHECKS_EXECUTED 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS_EXECUTED="* || " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " && -z "${PYTHON_SKIP_SANITY_CHECKS}" ]]; then
359 local PYTHON_ABI="${PYTHON_ABI}"
360 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI}}; do
361 # Ensure that appropriate version of Python is installed.
362 if ! has_version "$(python_get_implementational_package)"; then
363 die "$(python_get_implementational_package) is not installed"
364 fi
365
366 # Ensure that EPYTHON variable is respected.
367 if [[ "$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")" != "${PYTHON_ABI}" ]]; then
368 eerror "Path to 'python': '$(type -p python)'"
369 eerror "ABI: '${ABI}'"
370 eerror "DEFAULT_ABI: '${DEFAULT_ABI}'"
371 eerror "EPYTHON: '$(PYTHON)'"
372 eerror "PYTHON_ABI: '${PYTHON_ABI}'"
373 eerror "Locally active version of Python: '$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")'"
374 die "'python' does not respect EPYTHON variable"
375 fi
376 done
377 fi
378 PYTHON_SANITY_CHECKS_EXECUTED="1"
379}
380
381# @ECLASS-VARIABLE: PYTHON_COLORS
382# @DESCRIPTION:
383# User-configurable colored output.
384PYTHON_COLORS="${PYTHON_COLORS:-0}"
385
386_python_set_color_variables() {
387 if [[ "${PYTHON_COLORS}" != "0" && "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then
388 _BOLD=$'\e[1m'
389 _RED=$'\e[1;31m'
390 _GREEN=$'\e[1;32m'
391 _BLUE=$'\e[1;34m'
392 _CYAN=$'\e[1;36m'
393 _NORMAL=$'\e[0m'
394 else
395 _BOLD=
396 _RED=
397 _GREEN=
398 _BLUE=
399 _CYAN=
400 _NORMAL=
401 fi
402}
403
404_python_check_python_pkg_setup_execution() {
405 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return
406
407 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then
408 die "python_pkg_setup() not called"
409 fi
410}
411
170# @FUNCTION: python_pkg_setup 412# @FUNCTION: python_pkg_setup
171# @DESCRIPTION: 413# @DESCRIPTION:
172# Makes sure PYTHON_USE_WITH or PYTHON_USE_WITH_OR listed use flags 414# Perform sanity checks and initialize environment.
173# are respected. Only exported if one of those variables is set. 415#
174if ! has "${EAPI:-0}" 0 1 && [[ -n ${PYTHON_USE_WITH} || -n ${PYTHON_USE_WITH_OR} ]]; then 416# This function is exported in EAPI 2 and 3 when PYTHON_USE_WITH or PYTHON_USE_WITH_OR variable
417# is set and always in EAPI >=4. Calling of this function is mandatory in EAPI >=4.
175 python_pkg_setup() { 418python_pkg_setup() {
419 if [[ "${EBUILD_PHASE}" != "setup" ]]; then
420 die "${FUNCNAME}() can be used only in pkg_setup() phase"
421 fi
422
423 if [[ "$#" -ne 0 ]]; then
424 die "${FUNCNAME}() does not accept arguments"
425 fi
426
427 export JYTHON_SYSTEM_CACHEDIR="1"
428 addwrite "${EPREFIX}/var/cache/jython"
429
430 if _python_package_supporting_installation_for_multiple_python_abis; then
431 _python_calculate_PYTHON_ABIS
432 export EPYTHON="$(PYTHON -f)"
433 else
434 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
435 fi
436
437 if ! has "${EAPI:-0}" 0 1 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; then
438 if [[ "${PYTHON_USE_WITH_OPT}" ]]; then
439 if [[ "${PYTHON_USE_WITH_OPT}" == !* ]]; then
440 use ${PYTHON_USE_WITH_OPT#!} && return
441 else
442 use !${PYTHON_USE_WITH_OPT} && return
443 fi
444 fi
445
176 python_pkg_setup_fail() { 446 python_pkg_setup_check_USE_flags() {
177 eerror "${1}" 447 local python_atom USE_flag
178 die "${1}" 448 python_atom="$(python_get_implementational_package)"
449
450 for USE_flag in ${PYTHON_USE_WITH}; do
451 if ! has_version "${python_atom}[${USE_flag}]"; then
452 eerror "Please rebuild ${python_atom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
453 die "Please rebuild ${python_atom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
454 fi
455 done
456
457 for USE_flag in ${PYTHON_USE_WITH_OR}; do
458 if has_version "${python_atom}[${USE_flag}]"; then
459 return
460 fi
461 done
462
463 if [[ ${PYTHON_USE_WITH_OR} ]]; then
464 eerror "Please rebuild ${python_atom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
465 die "Please rebuild ${python_atom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
466 fi
179 } 467 }
180 468
181 [[ ${PYTHON_USE_WITH_OPT} ]] && use !${PYTHON_USE_WITH_OPT} && return 469 if _python_package_supporting_installation_for_multiple_python_abis; then
182
183 python_pkg_setup_check_USE_flags() {
184 local pyatom use
185 if [[ -n "${PYTHON_ABI}" ]]; then
186 pyatom="dev-lang/python:${PYTHON_ABI}"
187 else
188 pyatom="dev-lang/python:$(PYTHON -A --ABI)"
189 fi
190
191 for use in ${PYTHON_USE_WITH}; do
192 if ! has_version "${pyatom}[${use}]"; then
193 python_pkg_setup_fail "Please rebuild ${pyatom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
194 fi
195 done
196
197 for use in ${PYTHON_USE_WITH_OR}; do
198 if has_version "${pyatom}[${use}]"; then
199 return
200 fi
201 done
202
203 if [[ ${PYTHON_USE_WITH_OR} ]]; then
204 python_pkg_setup_fail "Please rebuild ${pyatom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
205 fi
206 }
207
208 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
209 python_execute_function -q python_pkg_setup_check_USE_flags 470 PYTHON_SKIP_SANITY_CHECKS="1" python_execute_function -q python_pkg_setup_check_USE_flags
210 else 471 else
211 python_pkg_setup_check_USE_flags 472 python_pkg_setup_check_USE_flags
212 fi 473 fi
474
475 unset -f python_pkg_setup_check_USE_flags
476 fi
477
478 PYTHON_PKG_SETUP_EXECUTED="1"
479}
480
481_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|pypy-c|python)'
482
483# @FUNCTION: python_convert_shebangs
484# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories]
485# @DESCRIPTION:
486# Convert shebangs in specified files. Directories can be specified only with --recursive option.
487python_convert_shebangs() {
488 _python_check_python_pkg_setup_execution
489
490 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0" shebangs_converted="0"
491
492 while (($#)); do
493 case "$1" in
494 -r|--recursive)
495 recursive="1"
496 ;;
497 -q|--quiet)
498 quiet="1"
499 ;;
500 -x|--only-executables)
501 only_executables="1"
502 ;;
503 --)
504 shift
505 break
506 ;;
507 -*)
508 die "${FUNCNAME}(): Unrecognized option '$1'"
509 ;;
510 *)
511 break
512 ;;
513 esac
514 shift
515 done
516
517 if [[ "$#" -eq 0 ]]; then
518 die "${FUNCNAME}(): Missing Python version and files or directories"
519 elif [[ "$#" -eq 1 ]]; then
520 die "${FUNCNAME}(): Missing files or directories"
521 fi
522
523 if [[ -n "$(_python_get_implementation --ignore-invalid "$1")" ]]; then
524 python_interpreter="$(PYTHON "$1")"
525 else
526 python_interpreter="python$1"
527 fi
528 shift
529
530 for argument in "$@"; do
531 if [[ ! -e "${argument}" ]]; then
532 die "${FUNCNAME}(): '${argument}' does not exist"
533 elif [[ -f "${argument}" ]]; then
534 files+=("${argument}")
535 elif [[ -d "${argument}" ]]; then
536 if [[ "${recursive}" == "1" ]]; then
537 while read -d $'\0' -r file; do
538 files+=("${file}")
539 done < <(find "${argument}" $([[ "${only_executables}" == "1" ]] && echo -perm /111) -type f -print0)
540 else
541 die "${FUNCNAME}(): '${argument}' is not a regular file"
542 fi
543 else
544 die "${FUNCNAME}(): '${argument}' is not a regular file or a directory"
545 fi
546 done
547
548 for file in "${files[@]}"; do
549 file="${file#./}"
550 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
551
552 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then
553 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
554
555 shebangs_converted="1"
556
557 if [[ "${quiet}" == "0" ]]; then
558 einfo "Converting shebang in '${file}'"
559 fi
560
561 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|pypy-c\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed"
562 fi
563 done
564
565 if [[ "${shebangs_converted}" == "0" ]]; then
566 ewarn "${FUNCNAME}(): Python scripts not found"
567 fi
568}
569
570# @FUNCTION: python_clean_py-compile_files
571# @USAGE: [-q|--quiet]
572# @DESCRIPTION:
573# Clean py-compile files to disable byte-compilation.
574python_clean_py-compile_files() {
575 _python_check_python_pkg_setup_execution
576
577 local file files=() quiet="0"
578
579 while (($#)); do
580 case "$1" in
581 -q|--quiet)
582 quiet="1"
583 ;;
584 -*)
585 die "${FUNCNAME}(): Unrecognized option '$1'"
586 ;;
587 *)
588 die "${FUNCNAME}(): Invalid usage"
589 ;;
590 esac
591 shift
592 done
593
594 while read -d $'\0' -r file; do
595 files+=("${file#./}")
596 done < <(find -name py-compile -type f -print0)
597
598 for file in "${files[@]}"; do
599 if [[ "${quiet}" == "0" ]]; then
600 einfo "Cleaning '${file}' file"
601 fi
602 echo "#!/bin/sh" > "${file}"
603 done
604}
605
606# @FUNCTION: python_clean_installation_image
607# @USAGE: [-q|--quiet]
608# @DESCRIPTION:
609# Delete needless files in installation image.
610#
611# This function can be used only in src_install() phase.
612python_clean_installation_image() {
613 if [[ "${EBUILD_PHASE}" != "install" ]]; then
614 die "${FUNCNAME}() can be used only in src_install() phase"
615 fi
616
617 _python_check_python_pkg_setup_execution
618 _python_initialize_prefix_variables
619
620 local file files=() quiet="0"
621
622 while (($#)); do
623 case "$1" in
624 -q|--quiet)
625 quiet="1"
626 ;;
627 -*)
628 die "${FUNCNAME}(): Unrecognized option '$1'"
629 ;;
630 *)
631 die "${FUNCNAME}(): Invalid usage"
632 ;;
633 esac
634 shift
635 done
636
637 while read -d $'\0' -r file; do
638 files+=("${file}")
639 done < <(find "${ED}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -type f -print0)
640
641 if [[ "${#files[@]}" -gt 0 ]]; then
642 if [[ "${quiet}" == "0" ]]; then
643 ewarn "Deleting byte-compiled Python modules needlessly generated by build system:"
644 fi
645 for file in "${files[@]}"; do
646 if [[ "${quiet}" == "0" ]]; then
647 ewarn " ${file}"
648 fi
649 rm -f "${file}"
650
651 # Delete empty __pycache__ directories.
652 if [[ "${file%/*}" == *"/__pycache__" ]]; then
653 rmdir "${file%/*}" 2> /dev/null
654 fi
655 done
656 fi
657
658 python_clean_sitedirs() {
659 if [[ -d "${ED}$(python_get_sitedir)" ]]; then
660 find "${ED}$(python_get_sitedir)" "(" -name "*.c" -o -name "*.h" -o -name "*.la" ")" -type f -print0 | xargs -0 rm -f
661 fi
213 } 662 }
214 663 if _python_package_supporting_installation_for_multiple_python_abis; then
215 EXPORT_FUNCTIONS pkg_setup 664 python_execute_function -q python_clean_sitedirs
216 665 else
217 _PYTHON_USE_WITH_ATOM="" 666 python_clean_sitedirs
218 if [[ -n "${PYTHON_USE_WITH}" ]]; then
219 while read _PYTHON_ATOM; do
220 _PYTHON_USE_WITH_ATOM+="${_PYTHON_USE_WITH_ATOM:+ }${_PYTHON_ATOM}[${PYTHON_USE_WITH/ /,}]"
221 done <<< "${_PYTHON_ATOMS}"
222 _PYTHON_USE_WITH_ATOM="|| ( ${_PYTHON_USE_WITH_ATOM} )"
223 elif [[ -n "${PYTHON_USE_WITH_OR}" ]]; then
224 for _USE_flag in ${PYTHON_USE_WITH_OR}; do
225 while read _PYTHON_ATOM; do
226 _PYTHON_USE_WITH_ATOM+="${_PYTHON_USE_WITH_ATOM:+ }${_PYTHON_ATOM}[${_USE_flag}]"
227 done <<< "${_PYTHON_ATOMS}"
228 done
229 unset _USE_flag
230 _PYTHON_USE_WITH_ATOM="|| ( ${_PYTHON_USE_WITH_ATOM} )"
231 fi
232 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then
233 _PYTHON_USE_WITH_ATOM="${PYTHON_USE_WITH_OPT}? ( ${_PYTHON_USE_WITH_ATOM} )"
234 fi
235 DEPEND+=" ${_PYTHON_USE_WITH_ATOM}"
236 RDEPEND+=" ${_PYTHON_USE_WITH_ATOM}"
237 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOM
238fi 667 fi
239 668
240unset _PYTHON_ATOMS 669 unset -f python_clean_sitedirs
670}
241 671
242# ================================================================================================ 672# ================================================================================================
243# ======== FUNCTIONS FOR PACKAGES SUPPORTING INSTALLATION FOR MULTIPLE VERSIONS OF PYTHON ======== 673# =========== FUNCTIONS FOR PACKAGES SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ============
244# ================================================================================================ 674# ================================================================================================
245 675
246# @ECLASS-VARIABLE: SUPPORT_PYTHON_ABIS 676# @ECLASS-VARIABLE: SUPPORT_PYTHON_ABIS
247# @DESCRIPTION: 677# @DESCRIPTION:
248# Set this in EAPI <= 4 to indicate that given package supports installation for 678# Set this in EAPI <= 4 to indicate that current package supports installation for
249# multiple versions of Python. 679# multiple Python ABIs.
250 680
681# @ECLASS-VARIABLE: PYTHON_TESTS_RESTRICTED_ABIS
682# @DESCRIPTION:
683# Space-separated list of Python ABI patterns. Testing in Python ABIs matching any Python ABI
684# patterns specified in this list is skipped.
685
251# @ECLASS-VARIABLE: PYTHON_DEFINE_DEFAULT_FUNCTIONS 686# @ECLASS-VARIABLE: PYTHON_EXPORT_PHASE_FUNCTIONS
252# @DESCRIPTION: 687# @DESCRIPTION:
253# Set this to define default functions for the following ebuild phases: 688# Set this to export phase functions for the following ebuild phases:
254# src_prepare, src_configure, src_compile, src_test, src_install. 689# src_prepare(), src_configure(), src_compile(), src_test(), src_install().
255if ! has "${EAPI:-0}" 0 1 && [[ -n "${PYTHON_DEFINE_DEFAULT_FUNCTIONS}" ]]; then 690if ! has "${EAPI:-0}" 0 1; then
256 python_src_prepare() { 691 python_src_prepare() {
692 if [[ "${EBUILD_PHASE}" != "prepare" ]]; then
693 die "${FUNCNAME}() can be used only in src_prepare() phase"
694 fi
695
696 if ! _python_package_supporting_installation_for_multiple_python_abis; then
697 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
698 fi
699
700 _python_check_python_pkg_setup_execution
701
702 if [[ "$#" -ne 0 ]]; then
703 die "${FUNCNAME}() does not accept arguments"
704 fi
705
257 python_copy_sources 706 python_copy_sources
258 } 707 }
259 708
260 for python_default_function in src_configure src_compile src_test src_install; do 709 for python_default_function in src_configure src_compile src_test; do
261 eval "python_${python_default_function}() { python_execute_function -d -s; }" 710 eval "python_${python_default_function}() {
711 if [[ \"\${EBUILD_PHASE}\" != \"${python_default_function#src_}\" ]]; then
712 die \"\${FUNCNAME}() can be used only in ${python_default_function}() phase\"
713 fi
714
715 if ! _python_package_supporting_installation_for_multiple_python_abis; then
716 die \"\${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs\"
717 fi
718
719 _python_check_python_pkg_setup_execution
720
721 python_execute_function -d -s -- \"\$@\"
722 }"
262 done 723 done
263 unset python_default_function 724 unset python_default_function
264 725
726 python_src_install() {
727 if [[ "${EBUILD_PHASE}" != "install" ]]; then
728 die "${FUNCNAME}() can be used only in src_install() phase"
729 fi
730
731 if ! _python_package_supporting_installation_for_multiple_python_abis; then
732 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
733 fi
734
735 _python_check_python_pkg_setup_execution
736
737 if has "${EAPI:-0}" 0 1 2 3; then
738 python_execute_function -d -s -- "$@"
739 else
740 python_installation() {
741 emake DESTDIR="${T}/images/${PYTHON_ABI}" install "$@"
742 }
743 python_execute_function -s python_installation "$@"
744 unset python_installation
745
746 python_merge_intermediate_installation_images "${T}/images"
747 fi
748 }
749
750 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then
265 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install 751 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install
752 fi
266fi 753fi
267 754
755if has "${EAPI:-0}" 0 1 2 3 4; then
268unset PYTHON_ABIS 756 unset PYTHON_ABIS
269unset PYTHON_ABIS_SANITY_CHECKS
270
271# @FUNCTION: validate_PYTHON_ABIS
272# @DESCRIPTION:
273# Ensure that PYTHON_ABIS variable has valid value.
274# This function usually should not be directly called in ebuilds.
275validate_PYTHON_ABIS() {
276 # Ensure that some functions cannot be accidentally successfully used in EAPI <= 4 without setting SUPPORT_PYTHON_ABIS variable.
277 if has "${EAPI:-0}" 0 1 2 3 4 && [[ -z "${SUPPORT_PYTHON_ABIS}" ]]; then
278 die "${FUNCNAME}() cannot be used in this EAPI without setting SUPPORT_PYTHON_ABIS variable"
279 fi 757fi
280 758
281 # Ensure that /usr/bin/python and /usr/bin/python-config are valid. 759_python_calculate_PYTHON_ABIS() {
282 if [[ "$(readlink "${EPREFIX}/usr/bin/python")" != "python-wrapper" ]]; then 760 if ! _python_package_supporting_installation_for_multiple_python_abis; then
283 eerror "'${EPREFIX}/usr/bin/python' is not valid symlink." 761 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
284 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
285 die "'${EPREFIX}/usr/bin/python' is not valid symlink"
286 fi 762 fi
287 if [[ "$(<"${EPREFIX}/usr/bin/python-config")" != *"Gentoo python-config wrapper script"* ]]; then
288 eerror "'${EPREFIX}/usr/bin/python-config' is not valid script"
289 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
290 die "'${EPREFIX}/usr/bin/python-config' is not valid script"
291 fi
292 763
293 # USE_${ABI_TYPE^^} and RESTRICT_${ABI_TYPE^^}_ABIS variables hopefully will be included in EAPI >= 5. 764 _python_initial_sanity_checks
765
294 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then 766 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then
295 local PYTHON_ABI restricted_ABI support_ABI supported_PYTHON_ABIS= 767 local PYTHON_ABI
296 PYTHON_ABI_SUPPORTED_VALUES="${_PYTHON2_SUPPORTED_VERSIONS[@]} ${_PYTHON3_SUPPORTED_VERSIONS[@]}"
297 768
298 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then 769 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then
299 local python2_enabled="0" python3_enabled="0" 770 local cpython_enabled="0"
300 771
301 if [[ -z "${USE_PYTHON}" ]]; then 772 if [[ -z "${USE_PYTHON}" ]]; then
302 die "USE_PYTHON variable is empty" 773 die "USE_PYTHON variable is empty"
303 fi 774 fi
304 775
305 for PYTHON_ABI in ${USE_PYTHON}; do 776 for PYTHON_ABI in ${USE_PYTHON}; do
306 if ! has "${PYTHON_ABI}" ${PYTHON_ABI_SUPPORTED_VALUES}; then 777 if ! has "${PYTHON_ABI}" "${_PYTHON_GLOBALLY_SUPPORTED_ABIS[@]}"; then
307 die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'" 778 die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'"
308 fi 779 fi
309 780
310 if has "${PYTHON_ABI}" "${_PYTHON2_SUPPORTED_VERSIONS[@]}"; then 781 if has "${PYTHON_ABI}" "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; then
311 python2_enabled="1" 782 cpython_enabled="1"
783 fi
784
785 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
786 export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
787 fi
788 done
789
790 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
791 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}"
312 fi 792 fi
313 if has "${PYTHON_ABI}" "${_PYTHON3_SUPPORTED_VERSIONS[@]}"; then 793
314 python3_enabled="1" 794 if [[ "${cpython_enabled}" == "0" ]]; then
795 die "USE_PYTHON variable does not enable any CPython ABI"
315 fi 796 fi
797 else
798 local python_version python2_version python3_version support_python_major_version
316 799
317 support_ABI="1" 800 if ! has_version "dev-lang/python"; then
318 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 801 die "${FUNCNAME}(): 'dev-lang/python' is not installed"
319 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then 802 fi
320 support_ABI="0" 803
804 python_version="$("${EPREFIX}/usr/bin/python" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
805
806 if has_version "=dev-lang/python-2*"; then
807 if [[ "$(readlink "${EPREFIX}/usr/bin/python2")" != "python2."* ]]; then
808 die "'${EPREFIX}/usr/bin/python2' is not valid symlink"
809 fi
810
811 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
812
813 support_python_major_version="0"
814 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do
815 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
816 support_python_major_version="1"
321 break 817 break
322 fi 818 fi
323 done 819 done
324 [[ "${support_ABI}" == "1" ]] && export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
325 done
326
327 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
328 die "USE_PYTHON variable does not enable any version of Python supported by ${CATEGORY}/${PF}"
329 fi
330
331 if [[ "${python2_enabled}" == "0" ]]; then
332 ewarn "USE_PYTHON variable does not enable any version of Python 2. This configuration is unsupported."
333 fi
334 if [[ "${python3_enabled}" == "0" ]]; then
335 ewarn "USE_PYTHON variable does not enable any version of Python 3. This configuration is unsupported."
336 fi
337 else
338 local python_version python2_version= python3_version= support_python_major_version
339
340 python_version="$("${EPREFIX}/usr/bin/python" -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')"
341
342 if has_version "=dev-lang/python-2*"; then
343 if [[ "$(readlink "${EPREFIX}/usr/bin/python2")" != "python2."* ]]; then
344 die "'${EPREFIX}/usr/bin/python2' is not valid symlink"
345 fi
346
347 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')"
348
349 for PYTHON_ABI in "${_PYTHON2_SUPPORTED_VERSIONS[@]}"; do
350 support_python_major_version="1"
351 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
352 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
353 support_python_major_version="0"
354 fi
355 done
356 [[ "${support_python_major_version}" == "1" ]] && break
357 done
358 if [[ "${support_python_major_version}" == "1" ]]; then 820 if [[ "${support_python_major_version}" == "1" ]]; then
359 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 821 if _python_check_python_abi_matching --patterns-list "${python2_version}" "${RESTRICT_PYTHON_ABIS}"; then
360 if [[ "${python2_version}" == ${restricted_ABI} ]]; then
361 die "Active version of Python 2 is not supported by ${CATEGORY}/${PF}" 822 die "Active version of CPython 2 is not supported by ${CATEGORY}/${PF}"
362 fi 823 fi
363 done
364 else 824 else
365 python2_version="" 825 python2_version=""
366 fi 826 fi
367 fi 827 fi
368 828
369 if has_version "=dev-lang/python-3*"; then 829 if has_version "=dev-lang/python-3*"; then
370 if [[ "$(readlink "${EPREFIX}/usr/bin/python3")" != "python3."* ]]; then 830 if [[ "$(readlink "${EPREFIX}/usr/bin/python3")" != "python3."* ]]; then
371 die "'${EPREFIX}/usr/bin/python3' is not valid symlink" 831 die "'${EPREFIX}/usr/bin/python3' is not valid symlink"
372 fi 832 fi
373 833
374 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')" 834 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
375 835
836 support_python_major_version="0"
376 for PYTHON_ABI in "${_PYTHON3_SUPPORTED_VERSIONS[@]}"; do 837 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
838 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
377 support_python_major_version="1" 839 support_python_major_version="1"
378 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 840 break
379 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
380 support_python_major_version="0"
381 fi 841 fi
382 done
383 [[ "${support_python_major_version}" == "1" ]] && break
384 done 842 done
385 if [[ "${support_python_major_version}" == "1" ]]; then 843 if [[ "${support_python_major_version}" == "1" ]]; then
386 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 844 if _python_check_python_abi_matching --patterns-list "${python3_version}" "${RESTRICT_PYTHON_ABIS}"; then
387 if [[ "${python3_version}" == ${restricted_ABI} ]]; then
388 die "Active version of Python 3 is not supported by ${CATEGORY}/${PF}" 845 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}"
389 fi 846 fi
390 done
391 else 847 else
392 python3_version="" 848 python3_version=""
393 fi 849 fi
850 fi
851
852 if [[ -z "${python2_version}" && -z "${python3_version}" ]]; then
853 eerror "${CATEGORY}/${PF} requires at least one of the following packages:"
854 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
855 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
856 eerror " dev-lang/python:${PYTHON_ABI}"
857 fi
858 done
859 die "No supported version of CPython installed"
394 fi 860 fi
395 861
396 if [[ -n "${python2_version}" && "${python_version}" == "2."* && "${python_version}" != "${python2_version}" ]]; then 862 if [[ -n "${python2_version}" && "${python_version}" == "2."* && "${python_version}" != "${python2_version}" ]]; then
397 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python2' symlink" 863 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python2' symlink"
398 eerror "is set incorrectly. Use \`eselect python\` to fix configuration." 864 eerror "is set incorrectly. Use \`eselect python\` to fix configuration."
408 PYTHON_ABIS="${PYTHON_ABIS# }" 874 PYTHON_ABIS="${PYTHON_ABIS# }"
409 export PYTHON_ABIS="${PYTHON_ABIS% }" 875 export PYTHON_ABIS="${PYTHON_ABIS% }"
410 fi 876 fi
411 fi 877 fi
412 878
413 if ! _python_implementation && [[ "$(declare -p PYTHON_ABIS_SANITY_CHECKS 2> /dev/null)" != "declare -- PYTHON_ABIS_SANITY_CHECKS="* ]]; then 879 _python_final_sanity_checks
414 local PYTHON_ABI 880}
415 for PYTHON_ABI in ${PYTHON_ABIS}; do 881
416 # Ensure that appropriate version of Python is installed. 882_python_prepare_flags() {
417 if ! has_version "dev-lang/python:${PYTHON_ABI}"; then 883 local array=() deleted_flag element flags new_value old_flag old_value operator pattern prefix variable
418 die "dev-lang/python:${PYTHON_ABI} is not installed" 884
885 for variable in CPPFLAGS CFLAGS CXXFLAGS LDFLAGS; do
886 eval "_PYTHON_SAVED_${variable}=\"\${!variable}\""
887 for prefix in PYTHON_USER_ PYTHON_; do
888 if [[ "$(declare -p ${prefix}${variable} 2> /dev/null)" == "declare -a ${prefix}${variable}="* ]]; then
889 eval "array=(\"\${${prefix}${variable}[@]}\")"
890 for element in "${array[@]}"; do
891 if [[ "${element}" =~ ^${_PYTHON_ABI_PATTERN_REGEX}\ (\+|-)\ .+ ]]; then
892 pattern="${element%% *}"
893 element="${element#* }"
894 operator="${element%% *}"
895 flags="${element#* }"
896 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then
897 if [[ "${operator}" == "+" ]]; then
898 eval "export ${variable}+=\"\${variable:+ }${flags}\""
899 elif [[ "${operator}" == "-" ]]; then
900 flags="${flags// /$'\n'}"
901 old_value="${!variable// /$'\n'}"
902 new_value=""
903 while read old_flag; do
904 while read deleted_flag; do
905 if [[ "${old_flag}" == ${deleted_flag} ]]; then
906 continue 2
907 fi
908 done <<< "${flags}"
909 new_value+="${new_value:+ }${old_flag}"
910 done <<< "${old_value}"
911 eval "export ${variable}=\"\${new_value}\""
912 fi
913 fi
914 else
915 die "Element '${element}' of ${prefix}${variable} array has invalid syntax"
419 fi 916 fi
420 917 done
421 # Ensure that EPYTHON variable is respected. 918 elif [[ -n "$(declare -p ${prefix}${variable} 2> /dev/null)" ]]; then
422 if [[ "$(EPYTHON="$(PYTHON)" python -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')" != "${PYTHON_ABI}" ]]; then 919 die "${prefix}${variable} should be indexed array"
423 eerror "python: '$(type -p python)'"
424 eerror "ABI: '${ABI}'"
425 eerror "DEFAULT_ABI: '${DEFAULT_ABI}'"
426 eerror "EPYTHON: '$(PYTHON)'"
427 eerror "PYTHON_ABI: '${PYTHON_ABI}'"
428 eerror "Version of enabled Python: '$(EPYTHON="$(PYTHON)" python -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')'"
429 die "'python' does not respect EPYTHON variable"
430 fi 920 fi
431 done 921 done
432 PYTHON_ABIS_SANITY_CHECKS="1" 922 done
433 fi 923}
924
925_python_restore_flags() {
926 local variable
927
928 for variable in CPPFLAGS CFLAGS CXXFLAGS LDFLAGS; do
929 eval "${variable}=\"\${_PYTHON_SAVED_${variable}}\""
930 unset _PYTHON_SAVED_${variable}
931 done
434} 932}
435 933
436# @FUNCTION: python_execute_function 934# @FUNCTION: python_execute_function
437# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments] 935# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [-f|--final-ABI] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments]
438# @DESCRIPTION: 936# @DESCRIPTION:
439# Execute specified function for each value of PYTHON_ABIS, optionally passing additional 937# Execute specified function for each value of PYTHON_ABIS, optionally passing additional
440# arguments. The specified function can use PYTHON_ABI and BUILDDIR variables. 938# arguments. The specified function can use PYTHON_ABI and BUILDDIR variables.
441python_execute_function() { 939python_execute_function() {
442 local action action_message action_message_template= default_function="0" failure_message failure_message_template= function i nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" separate_build_dirs="0" source_dir= 940 if ! _python_package_supporting_installation_for_multiple_python_abis; then
941 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
942 fi
943
944 _python_check_python_pkg_setup_execution
945 _python_set_color_variables
946
947 local action action_message action_message_template default_function="0" failure_message failure_message_template final_ABI="0" function iterated_PYTHON_ABIS nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" return_code separate_build_dirs="0" source_dir
443 948
444 while (($#)); do 949 while (($#)); do
445 case "$1" in 950 case "$1" in
446 --action-message) 951 --action-message)
447 action_message_template="$2" 952 action_message_template="$2"
452 ;; 957 ;;
453 --failure-message) 958 --failure-message)
454 failure_message_template="$2" 959 failure_message_template="$2"
455 shift 960 shift
456 ;; 961 ;;
962 -f|--final-ABI)
963 final_ABI="1"
964 ;;
457 --nonfatal) 965 --nonfatal)
458 nonfatal="1" 966 nonfatal="1"
459 ;; 967 ;;
460 -q|--quiet) 968 -q|--quiet)
461 quiet="1" 969 quiet="1"
494 1002
495 if [[ -z "$(type -t "${function}")" ]]; then 1003 if [[ -z "$(type -t "${function}")" ]]; then
496 die "${FUNCNAME}(): '${function}' function is not defined" 1004 die "${FUNCNAME}(): '${function}' function is not defined"
497 fi 1005 fi
498 else 1006 else
499 if [[ "$#" -ne 0 ]]; then
500 die "${FUNCNAME}(): '--default-function' option and function name cannot be specified simultaneously"
501 fi
502 if has "${EAPI:-0}" 0 1; then 1007 if has "${EAPI:-0}" 0 1; then
503 die "${FUNCNAME}(): '--default-function' option cannot be used in this EAPI" 1008 die "${FUNCNAME}(): '--default-function' option cannot be used in this EAPI"
504 fi 1009 fi
505 1010
506 if [[ "${EBUILD_PHASE}" == "configure" ]]; then 1011 if [[ "${EBUILD_PHASE}" == "configure" ]]; then
507 if has "${EAPI}" 2 3; then 1012 if has "${EAPI}" 2 3; then
508 python_default_function() { 1013 python_default_function() {
509 econf 1014 econf "$@"
510 } 1015 }
511 else 1016 else
512 python_default_function() { 1017 python_default_function() {
513 nonfatal econf 1018 nonfatal econf "$@"
514 } 1019 }
515 fi 1020 fi
516 elif [[ "${EBUILD_PHASE}" == "compile" ]]; then 1021 elif [[ "${EBUILD_PHASE}" == "compile" ]]; then
517 python_default_function() { 1022 python_default_function() {
518 emake 1023 emake "$@"
519 } 1024 }
520 elif [[ "${EBUILD_PHASE}" == "test" ]]; then 1025 elif [[ "${EBUILD_PHASE}" == "test" ]]; then
521 python_default_function() { 1026 python_default_function() {
1027 # Stolen from portage's _eapi0_src_test()
1028 local emake_cmd="${MAKE:-make} ${MAKEOPTS} ${EXTRA_EMAKE}"
522 if emake -j1 -n check &> /dev/null; then 1029 if ${emake_cmd} -j1 -n check &> /dev/null; then
523 emake -j1 check 1030 ${emake_cmd} -j1 check "$@"
524 elif emake -j1 -n test &> /dev/null; then 1031 elif ${emake_cmd} -j1 -n test &> /dev/null; then
525 emake -j1 test 1032 ${emake_cmd} -j1 test "$@"
526 fi 1033 fi
527 } 1034 }
528 elif [[ "${EBUILD_PHASE}" == "install" ]]; then 1035 elif [[ "${EBUILD_PHASE}" == "install" ]]; then
529 python_default_function() { 1036 python_default_function() {
530 emake DESTDIR="${D}" install 1037 emake DESTDIR="${D}" install "$@"
531 } 1038 }
532 else 1039 else
533 die "${FUNCNAME}(): '--default-function' option cannot be used in this ebuild phase" 1040 die "${FUNCNAME}(): '--default-function' option cannot be used in this ebuild phase"
534 fi 1041 fi
535 function="python_default_function" 1042 function="python_default_function"
536 fi 1043 fi
537 1044
538 for ((i = 1; i < "${#FUNCNAME[@]}"; i++)); do 1045 # Ensure that python_execute_function() cannot be directly or indirectly called by python_execute_function().
539 if [[ "${FUNCNAME[${i}]}" == "python_execute_function" ]]; then 1046 if _python_abi-specific_local_scope; then
540 die "${FUNCNAME}(): Invalid call stack" 1047 die "${FUNCNAME}(): Invalid call stack"
541 fi 1048 fi
542 done
543 1049
544 if [[ "${quiet}" == "0" ]]; then 1050 if [[ "${quiet}" == "0" ]]; then
545 [[ "${EBUILD_PHASE}" == "setup" ]] && action="Setting up" 1051 [[ "${EBUILD_PHASE}" == "setup" ]] && action="Setting up"
546 [[ "${EBUILD_PHASE}" == "unpack" ]] && action="Unpacking" 1052 [[ "${EBUILD_PHASE}" == "unpack" ]] && action="Unpacking"
547 [[ "${EBUILD_PHASE}" == "prepare" ]] && action="Preparation" 1053 [[ "${EBUILD_PHASE}" == "prepare" ]] && action="Preparation"
553 [[ "${EBUILD_PHASE}" == "postinst" ]] && action="Postinstallation" 1059 [[ "${EBUILD_PHASE}" == "postinst" ]] && action="Postinstallation"
554 [[ "${EBUILD_PHASE}" == "prerm" ]] && action="Preuninstallation" 1060 [[ "${EBUILD_PHASE}" == "prerm" ]] && action="Preuninstallation"
555 [[ "${EBUILD_PHASE}" == "postrm" ]] && action="Postuninstallation" 1061 [[ "${EBUILD_PHASE}" == "postrm" ]] && action="Postuninstallation"
556 fi 1062 fi
557 1063
558 local RED GREEN BLUE NORMAL 1064 _python_calculate_PYTHON_ABIS
559 if [[ "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then 1065 if [[ "${final_ABI}" == "1" ]]; then
560 RED=$'\e[1;31m' 1066 iterated_PYTHON_ABIS="$(PYTHON -f --ABI)"
561 GREEN=$'\e[1;32m'
562 BLUE=$'\e[1;34m'
563 NORMAL=$'\e[0m'
564 else 1067 else
565 RED= 1068 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
566 GREEN=
567 BLUE=
568 NORMAL=
569 fi 1069 fi
570
571 validate_PYTHON_ABIS
572 for PYTHON_ABI in ${PYTHON_ABIS}; do 1070 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
1071 if [[ "${EBUILD_PHASE}" == "test" ]] && _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${PYTHON_TESTS_RESTRICTED_ABIS}"; then
1072 if [[ "${quiet}" == "0" ]]; then
1073 echo " ${_GREEN}*${_NORMAL} ${_BLUE}Testing of ${CATEGORY}/${PF} with $(python_get_implementation_and_version) skipped${_NORMAL}"
1074 fi
1075 continue
1076 fi
1077
1078 _python_prepare_flags
1079
573 if [[ "${quiet}" == "0" ]]; then 1080 if [[ "${quiet}" == "0" ]]; then
574 if [[ -n "${action_message_template}" ]]; then 1081 if [[ -n "${action_message_template}" ]]; then
575 action_message="$(eval echo -n "${action_message_template}")" 1082 eval "action_message=\"${action_message_template}\""
576 else 1083 else
577 action_message="${action} of ${CATEGORY}/${PF} with Python ${PYTHON_ABI}..." 1084 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation_and_version)..."
578 fi 1085 fi
579 echo " ${GREEN}*${NORMAL} ${BLUE}${action_message}${NORMAL}" 1086 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}"
580 fi 1087 fi
581 1088
582 if [[ "${separate_build_dirs}" == "1" ]]; then 1089 if [[ "${separate_build_dirs}" == "1" ]]; then
583 if [[ -n "${source_dir}" ]]; then 1090 if [[ -n "${source_dir}" ]]; then
584 export BUILDDIR="${S}/${source_dir}-${PYTHON_ABI}" 1091 export BUILDDIR="${S}/${source_dir}-${PYTHON_ABI}"
598 EPYTHON="$(PYTHON)" nonfatal "${function}" "$@" 1105 EPYTHON="$(PYTHON)" nonfatal "${function}" "$@"
599 else 1106 else
600 EPYTHON="$(PYTHON)" "${function}" "$@" 1107 EPYTHON="$(PYTHON)" "${function}" "$@"
601 fi 1108 fi
602 1109
603 if [[ "$?" != "0" ]]; then 1110 return_code="$?"
1111
1112 _python_restore_flags
1113
1114 if [[ "${return_code}" -ne 0 ]]; then
604 if [[ -n "${failure_message_template}" ]]; then 1115 if [[ -n "${failure_message_template}" ]]; then
605 failure_message="$(eval echo -n "${failure_message_template}")" 1116 eval "failure_message=\"${failure_message_template}\""
606 else 1117 else
607 failure_message="${action} failed with Python ${PYTHON_ABI} in ${function}() function" 1118 failure_message="${action} failed with $(python_get_implementation_and_version) in ${function}() function"
608 fi 1119 fi
609 1120
610 if [[ "${nonfatal}" == "1" ]]; then 1121 if [[ "${nonfatal}" == "1" ]]; then
611 if [[ "${quiet}" == "0" ]]; then 1122 if [[ "${quiet}" == "0" ]]; then
612 ewarn "${RED}${failure_message}${NORMAL}" 1123 ewarn "${failure_message}"
613 fi 1124 fi
614 elif has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then 1125 elif [[ "${final_ABI}" == "0" ]] && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then
615 if [[ "${EBUILD_PHASE}" != "test" ]] || ! has test-fail-continue ${FEATURES}; then 1126 if [[ "${EBUILD_PHASE}" != "test" ]] || ! has test-fail-continue ${FEATURES}; then
616 local enabled_PYTHON_ABIS= other_PYTHON_ABI 1127 local enabled_PYTHON_ABIS= other_PYTHON_ABI
617 for other_PYTHON_ABI in ${PYTHON_ABIS}; do 1128 for other_PYTHON_ABI in ${PYTHON_ABIS}; do
618 [[ "${other_PYTHON_ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+="${enabled_PYTHON_ABIS:+ }${other_PYTHON_ABI}" 1129 [[ "${other_PYTHON_ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+="${enabled_PYTHON_ABIS:+ }${other_PYTHON_ABI}"
619 done 1130 done
620 export PYTHON_ABIS="${enabled_PYTHON_ABIS}" 1131 export PYTHON_ABIS="${enabled_PYTHON_ABIS}"
621 fi 1132 fi
622 if [[ "${quiet}" == "0" ]]; then 1133 if [[ "${quiet}" == "0" ]]; then
623 ewarn "${RED}${failure_message}${NORMAL}" 1134 ewarn "${failure_message}"
624 fi 1135 fi
625 if [[ -z "${PYTHON_ABIS}" ]]; then 1136 if [[ -z "${PYTHON_ABIS}" ]]; then
626 die "${function}() function failed with all enabled versions of Python" 1137 die "${function}() function failed with all enabled Python ABIs"
627 fi 1138 fi
628 else 1139 else
629 die "${failure_message}" 1140 die "${failure_message}"
630 fi 1141 fi
631 fi 1142 fi
661 unset -f python_default_function 1172 unset -f python_default_function
662 fi 1173 fi
663} 1174}
664 1175
665# @FUNCTION: python_copy_sources 1176# @FUNCTION: python_copy_sources
666# @USAGE: [--no-link] [--] [directory] 1177# @USAGE: <directory="${S}"> [directory]
667# @DESCRIPTION: 1178# @DESCRIPTION:
668# Copy unpacked sources of given package to separate build directory for each Python ABI. 1179# Copy unpacked sources of current package to separate build directory for each Python ABI.
669python_copy_sources() { 1180python_copy_sources() {
1181 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1182 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1183 fi
1184
1185 _python_check_python_pkg_setup_execution
1186
670 local dir dirs=() no_link="0" PYTHON_ABI 1187 local dir dirs=() PYTHON_ABI
671
672 while (($#)); do
673 case "$1" in
674 --no-link)
675 no_link="1"
676 ;;
677 --)
678 shift
679 break
680 ;;
681 -*)
682 die "${FUNCNAME}(): Unrecognized option '$1'"
683 ;;
684 *)
685 break
686 ;;
687 esac
688 shift
689 done
690 1188
691 if [[ "$#" -eq 0 ]]; then 1189 if [[ "$#" -eq 0 ]]; then
692 if [[ "${WORKDIR}" == "${S}" ]]; then 1190 if [[ "${WORKDIR}" == "${S}" ]]; then
693 die "${FUNCNAME}() cannot be used" 1191 die "${FUNCNAME}() cannot be used with current value of S variable"
694 fi 1192 fi
695 dirs="${S}" 1193 dirs=("${S%/}")
696 else 1194 else
697 dirs="$@" 1195 dirs=("$@")
698 fi 1196 fi
699 1197
700 validate_PYTHON_ABIS 1198 _python_calculate_PYTHON_ABIS
701 for PYTHON_ABI in ${PYTHON_ABIS}; do 1199 for PYTHON_ABI in ${PYTHON_ABIS}; do
702 for dir in "${dirs[@]}"; do 1200 for dir in "${dirs[@]}"; do
703 if [[ "${no_link}" == "1" ]]; then
704 cp -pr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed" 1201 cp -pr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed"
705 else
706 cp -lpr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed"
707 fi
708 done 1202 done
709 done 1203 done
710}
711
712# @FUNCTION: python_set_build_dir_symlink
713# @USAGE: [directory="build"]
714# @DESCRIPTION:
715# Create build directory symlink.
716python_set_build_dir_symlink() {
717 local dir="$1"
718
719 [[ -z "${PYTHON_ABI}" ]] && die "PYTHON_ABI variable not set"
720 [[ -z "${dir}" ]] && dir="build"
721
722 # Do not delete preexistent directories.
723 rm -f "${dir}" || die "Deletion of '${dir}' failed"
724 ln -s "${dir}-${PYTHON_ABI}" "${dir}" || die "Creation of '${dir}' directory symlink failed"
725} 1204}
726 1205
727# @FUNCTION: python_generate_wrapper_scripts 1206# @FUNCTION: python_generate_wrapper_scripts
728# @USAGE: [-E|--respect-EPYTHON] [-f|--force] [-q|--quiet] [--] <file> [files] 1207# @USAGE: [-E|--respect-EPYTHON] [-f|--force] [-q|--quiet] [--] <file> [files]
729# @DESCRIPTION: 1208# @DESCRIPTION:
730# Generate wrapper scripts. Existing files are overwritten only with --force option. 1209# Generate wrapper scripts. Existing files are overwritten only with --force option.
731# If --respect-EPYTHON option is specified, then generated wrapper scripts will 1210# If --respect-EPYTHON option is specified, then generated wrapper scripts will
732# respect EPYTHON variable at run time. 1211# respect EPYTHON variable at run time.
1212#
1213# This function can be used only in src_install() phase.
733python_generate_wrapper_scripts() { 1214python_generate_wrapper_scripts() {
1215 if [[ "${EBUILD_PHASE}" != "install" ]]; then
1216 die "${FUNCNAME}() can be used only in src_install() phase"
1217 fi
1218
1219 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1220 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1221 fi
1222
1223 _python_check_python_pkg_setup_execution
734 _python_initialize_prefix_variables 1224 _python_initialize_prefix_variables
735 1225
736 local eselect_python_option file force="0" quiet="0" PYTHON_ABI python2_enabled="0" python3_enabled="0" respect_EPYTHON="0" 1226 local eselect_python_option file force="0" quiet="0" PYTHON_ABI PYTHON_ABIS_list python2_enabled="0" python3_enabled="0" respect_EPYTHON="0"
737 1227
738 while (($#)); do 1228 while (($#)); do
739 case "$1" in 1229 case "$1" in
740 -E|--respect-EPYTHON) 1230 -E|--respect-EPYTHON)
741 respect_EPYTHON="1" 1231 respect_EPYTHON="1"
762 1252
763 if [[ "$#" -eq 0 ]]; then 1253 if [[ "$#" -eq 0 ]]; then
764 die "${FUNCNAME}(): Missing arguments" 1254 die "${FUNCNAME}(): Missing arguments"
765 fi 1255 fi
766 1256
767 validate_PYTHON_ABIS 1257 _python_calculate_PYTHON_ABIS
768 for PYTHON_ABI in "${_PYTHON2_SUPPORTED_VERSIONS[@]}"; do 1258 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do
769 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then 1259 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
770 python2_enabled="1" 1260 python2_enabled="1"
771 fi 1261 fi
772 done 1262 done
773 for PYTHON_ABI in "${_PYTHON3_SUPPORTED_VERSIONS[@]}"; do 1263 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
774 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then 1264 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
775 python3_enabled="1" 1265 python3_enabled="1"
776 fi 1266 fi
777 done 1267 done
778 1268
784 eselect_python_option="--python3" 1274 eselect_python_option="--python3"
785 else 1275 else
786 die "${FUNCNAME}(): Unsupported environment" 1276 die "${FUNCNAME}(): Unsupported environment"
787 fi 1277 fi
788 1278
1279 PYTHON_ABIS_list="$("$(PYTHON -f)" -c "print(', '.join('\"%s\"' % x for x in reversed('${PYTHON_ABIS}'.split())))")"
1280
789 for file in "$@"; do 1281 for file in "$@"; do
790 if [[ -f "${file}" && "${force}" == "0" ]]; then 1282 if [[ -f "${file}" && "${force}" == "0" ]]; then
791 die "${FUNCNAME}(): '$1' already exists" 1283 die "${FUNCNAME}(): '${file}' already exists"
792 fi 1284 fi
793 1285
794 if [[ "${quiet}" == "0" ]]; then 1286 if [[ "${quiet}" == "0" ]]; then
795 einfo "Generating '${file#${D%/}}' wrapper script" 1287 einfo "Generating '${file#${ED%/}}' wrapper script"
796 fi 1288 fi
797 1289
798 cat << EOF > "${file}" 1290 cat << EOF > "${file}"
799#!/usr/bin/env python 1291#!/usr/bin/env python
800# Gentoo '${file##*/}' wrapper script 1292# Gentoo '${file##*/}' wrapper script generated by python_generate_wrapper_scripts()
801 1293
802import os 1294import os
803import re 1295import re
804import subprocess 1296import subprocess
805import sys 1297import sys
806 1298
1299cpython_ABI_re = re.compile(r"^(\d+\.\d+)$")
1300jython_ABI_re = re.compile(r"^(\d+\.\d+)-jython$")
1301pypy_ABI_re = re.compile(r"^\d+\.\d+-pypy-(\d+\.\d+)$")
807EPYTHON_re = re.compile(r"^python(\d+\.\d+)$") 1302cpython_interpreter_re = re.compile(r"^python(\d+\.\d+)$")
1303jython_interpreter_re = re.compile(r"^jython(\d+\.\d+)$")
1304pypy_interpreter_re = re.compile(r"^pypy-c(\d+\.\d+)$")
1305cpython_shebang_re = re.compile(r"^#![ \t]*(?:${EPREFIX}/usr/bin/python|(?:${EPREFIX})?/usr/bin/env[ \t]+(?:${EPREFIX}/usr/bin/)?python)")
1306python_shebang_options_re = re.compile(r"^#![ \t]*${EPREFIX}/usr/bin/(?:jython|pypy-c|python)(?:\d+(?:\.\d+)?)?[ \t]+(-\S)")
1307python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$")
1308
1309pypy_versions_mapping = {
1310 "1.5": "2.7",
1311 "1.6": "2.7",
1312 "1.7": "2.7",
1313 "1.8": "2.7",
1314 "1.9": "2.7",
1315}
1316
1317def get_PYTHON_ABI(python_interpreter):
1318 cpython_matched = cpython_interpreter_re.match(python_interpreter)
1319 jython_matched = jython_interpreter_re.match(python_interpreter)
1320 pypy_matched = pypy_interpreter_re.match(python_interpreter)
1321 if cpython_matched is not None:
1322 PYTHON_ABI = cpython_matched.group(1)
1323 elif jython_matched is not None:
1324 PYTHON_ABI = jython_matched.group(1) + "-jython"
1325 elif pypy_matched is not None:
1326 PYTHON_ABI = pypy_versions_mapping[pypy_matched.group(1)] + "-pypy-" + pypy_matched.group(1)
1327 else:
1328 PYTHON_ABI = None
1329 return PYTHON_ABI
1330
1331def get_python_interpreter(PYTHON_ABI):
1332 cpython_matched = cpython_ABI_re.match(PYTHON_ABI)
1333 jython_matched = jython_ABI_re.match(PYTHON_ABI)
1334 pypy_matched = pypy_ABI_re.match(PYTHON_ABI)
1335 if cpython_matched is not None:
1336 python_interpreter = "python" + cpython_matched.group(1)
1337 elif jython_matched is not None:
1338 python_interpreter = "jython" + jython_matched.group(1)
1339 elif pypy_matched is not None:
1340 python_interpreter = "pypy-c" + pypy_matched.group(1)
1341 else:
1342 python_interpreter = None
1343 return python_interpreter
808 1344
809EOF 1345EOF
810 if [[ "$?" != "0" ]]; then 1346 if [[ "$?" != "0" ]]; then
811 die "${FUNCNAME}(): Generation of '$1' failed" 1347 die "${FUNCNAME}(): Generation of '$1' failed"
812 fi 1348 fi
813 if [[ "${respect_EPYTHON}" == "1" ]]; then 1349 if [[ "${respect_EPYTHON}" == "1" ]]; then
814 cat << EOF >> "${file}" 1350 cat << EOF >> "${file}"
815EPYTHON = os.environ.get("EPYTHON") 1351python_interpreter = os.environ.get("EPYTHON")
816if EPYTHON: 1352if python_interpreter:
817 EPYTHON_matched = EPYTHON_re.match(EPYTHON) 1353 PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
818 if EPYTHON_matched: 1354 if PYTHON_ABI is None:
819 PYTHON_ABI = EPYTHON_matched.group(1)
820 else:
821 sys.stderr.write("EPYTHON variable has unrecognized value '%s'\n" % EPYTHON) 1355 sys.stderr.write("%s: EPYTHON variable has unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
822 sys.exit(1) 1356 sys.exit(1)
823else: 1357else:
824 try: 1358 try:
1359 environment = os.environ.copy()
1360 environment["ROOT"] = "/"
825 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE) 1361 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], env=environment, stdout=subprocess.PIPE)
826 if eselect_process.wait() != 0: 1362 if eselect_process.wait() != 0:
827 raise ValueError 1363 raise ValueError
828 except (OSError, ValueError): 1364 except (OSError, ValueError):
829 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n") 1365 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
830 sys.exit(1) 1366 sys.exit(1)
831 1367
832 eselect_output = eselect_process.stdout.read() 1368 python_interpreter = eselect_process.stdout.read()
833 if not isinstance(eselect_output, str): 1369 if not isinstance(python_interpreter, str):
834 # Python 3 1370 # Python 3
835 eselect_output = eselect_output.decode() 1371 python_interpreter = python_interpreter.decode()
1372 python_interpreter = python_interpreter.rstrip("\n")
836 1373
837 EPYTHON_matched = EPYTHON_re.match(eselect_output) 1374 PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
838 if EPYTHON_matched: 1375 if PYTHON_ABI is None:
839 PYTHON_ABI = EPYTHON_matched.group(1)
840 else:
841 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s" % eselect_output) 1376 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
842 sys.exit(1) 1377 sys.exit(1)
843EOF
844 if [[ "$?" != "0" ]]; then
845 die "${FUNCNAME}(): Generation of '$1' failed"
846 fi
847 else
848 cat << EOF >> "${file}"
849try:
850 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE)
851 if eselect_process.wait() != 0:
852 raise ValueError
853except (OSError, ValueError):
854 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n")
855 sys.exit(1)
856 1378
857eselect_output = eselect_process.stdout.read() 1379wrapper_script_path = os.path.realpath(sys.argv[0])
858if not isinstance(eselect_output, str): 1380target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
859 # Python 3 1381if not os.path.exists(target_executable_path):
860 eselect_output = eselect_output.decode() 1382 sys.stderr.write("%s: '%s' does not exist\n" % (sys.argv[0], target_executable_path))
861
862EPYTHON_matched = EPYTHON_re.match(eselect_output)
863if EPYTHON_matched:
864 PYTHON_ABI = EPYTHON_matched.group(1)
865else:
866 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s" % eselect_output)
867 sys.exit(1) 1383 sys.exit(1)
868EOF 1384EOF
869 if [[ "$?" != "0" ]]; then 1385 if [[ "$?" != "0" ]]; then
870 die "${FUNCNAME}(): Generation of '$1' failed" 1386 die "${FUNCNAME}(): Generation of '$1' failed"
871 fi 1387 fi
1388 else
1389 cat << EOF >> "${file}"
1390try:
1391 environment = os.environ.copy()
1392 environment["ROOT"] = "/"
1393 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], env=environment, stdout=subprocess.PIPE)
1394 if eselect_process.wait() != 0:
1395 raise ValueError
1396except (OSError, ValueError):
1397 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
1398 sys.exit(1)
1399
1400python_interpreter = eselect_process.stdout.read()
1401if not isinstance(python_interpreter, str):
1402 # Python 3
1403 python_interpreter = python_interpreter.decode()
1404python_interpreter = python_interpreter.rstrip("\n")
1405
1406PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1407if PYTHON_ABI is None:
1408 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1409 sys.exit(1)
1410
1411wrapper_script_path = os.path.realpath(sys.argv[0])
1412for PYTHON_ABI in [PYTHON_ABI, ${PYTHON_ABIS_list}]:
1413 target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1414 if os.path.exists(target_executable_path):
1415 break
1416else:
1417 sys.stderr.write("%s: No target script exists for '%s'\n" % (sys.argv[0], wrapper_script_path))
1418 sys.exit(1)
1419
1420python_interpreter = get_python_interpreter(PYTHON_ABI)
1421if python_interpreter is None:
1422 sys.stderr.write("%s: Unrecognized Python ABI '%s'\n" % (sys.argv[0], PYTHON_ABI))
1423 sys.exit(1)
1424EOF
1425 if [[ "$?" != "0" ]]; then
1426 die "${FUNCNAME}(): Generation of '$1' failed"
1427 fi
872 fi 1428 fi
873 cat << EOF >> "${file}" 1429 cat << EOF >> "${file}"
874 1430
1431target_executable = open(target_executable_path, "rb")
1432target_executable_first_line = target_executable.readline()
1433target_executable.close()
1434if not isinstance(target_executable_first_line, str):
1435 # Python 3
1436 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace")
1437
1438options = []
1439python_shebang_options_matched = python_shebang_options_re.match(target_executable_first_line)
1440if python_shebang_options_matched is not None:
1441 options = [python_shebang_options_matched.group(1)]
1442
1443cpython_shebang_matched = cpython_shebang_re.match(target_executable_first_line)
1444
1445if cpython_shebang_matched is not None:
1446 try:
1447 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % python_interpreter
1448 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1"
1449 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE)
1450 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"]
1451 if python_verification_process.wait() != 0:
1452 raise ValueError
1453
1454 python_verification_output = python_verification_process.stdout.read()
1455 if not isinstance(python_verification_output, str):
1456 # Python 3
1457 python_verification_output = python_verification_output.decode()
1458
1459 if not python_verification_output_re.match(python_verification_output):
1460 raise ValueError
1461
1462 if cpython_interpreter_re.match(python_interpreter) is not None:
875os.environ["PYTHON_PROCESS_NAME"] = sys.argv[0] 1463 os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0])
876target_executable = "%s-%s" % (os.path.realpath(sys.argv[0]), PYTHON_ABI) 1464 os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0]
877if not os.path.exists(target_executable): 1465 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path
878 sys.stderr.write("'%s' does not exist\n" % target_executable)
879 sys.exit(1)
880 1466
1467 if hasattr(os, "execv"):
1468 os.execv(python_interpreter_path, [python_interpreter_path] + options + sys.argv)
1469 else:
1470 sys.exit(subprocess.Popen([python_interpreter_path] + options + sys.argv).wait())
1471 except (KeyboardInterrupt, SystemExit):
1472 raise
1473 except:
1474 pass
1475 for variable in ("GENTOO_PYTHON_PROCESS_NAME", "GENTOO_PYTHON_WRAPPER_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"):
1476 if variable in os.environ:
1477 del os.environ[variable]
1478
1479if hasattr(os, "execv"):
881os.execv(target_executable, sys.argv) 1480 os.execv(target_executable_path, sys.argv)
1481else:
1482 sys.exit(subprocess.Popen([target_executable_path] + sys.argv[1:]).wait())
882EOF 1483EOF
883 if [[ "$?" != "0" ]]; then 1484 if [[ "$?" != "0" ]]; then
884 die "${FUNCNAME}(): Generation of '$1' failed" 1485 die "${FUNCNAME}(): Generation of '$1' failed"
885 fi 1486 fi
886 fperms +x "${file#${ED%/}}" || die "fperms '${file}' failed" 1487 fperms +x "${file#${ED%/}}" || die "fperms '${file}' failed"
887 done 1488 done
888} 1489}
889 1490
1491# @ECLASS-VARIABLE: PYTHON_VERSIONED_SCRIPTS
1492# @DESCRIPTION:
1493# Array of regular expressions of paths to versioned Python scripts.
1494# Python scripts in /usr/bin and /usr/sbin are versioned by default.
1495
1496# @ECLASS-VARIABLE: PYTHON_VERSIONED_EXECUTABLES
1497# @DESCRIPTION:
1498# Array of regular expressions of paths to versioned executables (including Python scripts).
1499
1500# @ECLASS-VARIABLE: PYTHON_NONVERSIONED_EXECUTABLES
1501# @DESCRIPTION:
1502# Array of regular expressions of paths to nonversioned executables (including Python scripts).
1503
1504# @FUNCTION: python_merge_intermediate_installation_images
1505# @USAGE: [-q|--quiet] [--] <intermediate_installation_images_directory>
1506# @DESCRIPTION:
1507# Merge intermediate installation images into installation image.
1508#
1509# This function can be used only in src_install() phase.
1510python_merge_intermediate_installation_images() {
1511 if [[ "${EBUILD_PHASE}" != "install" ]]; then
1512 die "${FUNCNAME}() can be used only in src_install() phase"
1513 fi
1514
1515 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1516 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1517 fi
1518
1519 _python_check_python_pkg_setup_execution
1520 _python_initialize_prefix_variables
1521
1522 local absolute_file b file files=() intermediate_installation_images_directory PYTHON_ABI quiet="0" regex shebang version_executable wrapper_scripts=() wrapper_scripts_set=()
1523
1524 while (($#)); do
1525 case "$1" in
1526 -q|--quiet)
1527 quiet="1"
1528 ;;
1529 --)
1530 shift
1531 break
1532 ;;
1533 -*)
1534 die "${FUNCNAME}(): Unrecognized option '$1'"
1535 ;;
1536 *)
1537 break
1538 ;;
1539 esac
1540 shift
1541 done
1542
1543 if [[ "$#" -ne 1 ]]; then
1544 die "${FUNCNAME}() requires 1 argument"
1545 fi
1546
1547 intermediate_installation_images_directory="$1"
1548
1549 if [[ ! -d "${intermediate_installation_images_directory}" ]]; then
1550 die "${FUNCNAME}(): Intermediate installation images directory '${intermediate_installation_images_directory}' does not exist"
1551 fi
1552
1553 _python_calculate_PYTHON_ABIS
1554 if [[ "$(PYTHON -f --ABI)" == 3.* ]]; then
1555 b="b"
1556 fi
1557
1558 while read -d $'\0' -r file; do
1559 files+=("${file}")
1560 done < <("$(PYTHON -f)" -c \
1561"import os
1562import sys
1563
1564if hasattr(sys.stdout, 'buffer'):
1565 # Python 3
1566 stdout = sys.stdout.buffer
1567else:
1568 # Python 2
1569 stdout = sys.stdout
1570
1571files_set = set()
1572
1573os.chdir(${b}'${intermediate_installation_images_directory}')
1574
1575for PYTHON_ABI in ${b}'${PYTHON_ABIS}'.split():
1576 for root, dirs, files in os.walk(PYTHON_ABI + ${b}'${EPREFIX}'):
1577 root = root[len(PYTHON_ABI + ${b}'${EPREFIX}')+1:]
1578 files_set.update(root + ${b}'/' + file for file in files)
1579
1580for file in sorted(files_set):
1581 stdout.write(file)
1582 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of files in intermediate installation images")
1583
1584 for PYTHON_ABI in ${PYTHON_ABIS}; do
1585 if [[ ! -d "${intermediate_installation_images_directory}/${PYTHON_ABI}" ]]; then
1586 die "${FUNCNAME}(): Intermediate installation image for Python ABI '${PYTHON_ABI}' does not exist"
1587 fi
1588
1589 pushd "${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}" > /dev/null || die "pushd failed"
1590
1591 for file in "${files[@]}"; do
1592 version_executable="0"
1593 for regex in "/usr/bin/.*" "/usr/sbin/.*" "${PYTHON_VERSIONED_SCRIPTS[@]}"; do
1594 if [[ "/${file}" =~ ^${regex}$ ]]; then
1595 version_executable="1"
1596 break
1597 fi
1598 done
1599 for regex in "${PYTHON_VERSIONED_EXECUTABLES[@]}"; do
1600 if [[ "/${file}" =~ ^${regex}$ ]]; then
1601 version_executable="2"
1602 break
1603 fi
1604 done
1605 if [[ "${version_executable}" != "0" ]]; then
1606 for regex in "${PYTHON_NONVERSIONED_EXECUTABLES[@]}"; do
1607 if [[ "/${file}" =~ ^${regex}$ ]]; then
1608 version_executable="0"
1609 break
1610 fi
1611 done
1612 fi
1613
1614 [[ "${version_executable}" == "0" ]] && continue
1615
1616 if [[ -L "${file}" ]]; then
1617 absolute_file="$(readlink "${file}")"
1618 if [[ "${absolute_file}" == /* ]]; then
1619 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${absolute_file##/}"
1620 else
1621 if [[ "${file}" == */* ]]; then
1622 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${file%/*}/${absolute_file}"
1623 else
1624 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${absolute_file}"
1625 fi
1626 fi
1627 else
1628 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${file}"
1629 fi
1630
1631 [[ ! -x "${absolute_file}" ]] && continue
1632
1633 shebang="$(head -n1 "${absolute_file}")" || die "Extraction of shebang from '${absolute_file}' failed"
1634
1635 if [[ "${version_executable}" == "2" ]]; then
1636 wrapper_scripts+=("${ED}${file}")
1637 elif [[ "${version_executable}" == "1" ]]; then
1638 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}([[:digit:]]+(\.[[:digit:]]+)?)?($|[[:space:]]+) ]]; then
1639 wrapper_scripts+=("${ED}${file}")
1640 else
1641 version_executable="0"
1642 fi
1643 fi
1644
1645 [[ "${version_executable}" == "0" ]] && continue
1646
1647 if [[ -e "${file}-${PYTHON_ABI}" ]]; then
1648 die "${FUNCNAME}(): '${EPREFIX}/${file}-${PYTHON_ABI}' already exists"
1649 fi
1650
1651 mv "${file}" "${file}-${PYTHON_ABI}" || die "Renaming of '${file}' failed"
1652
1653 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}[[:digit:]]*($|[[:space:]]+) ]]; then
1654 if [[ -L "${file}-${PYTHON_ABI}" ]]; then
1655 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${absolute_file}"
1656 else
1657 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${file}-${PYTHON_ABI}"
1658 fi
1659 fi
1660 done
1661
1662 popd > /dev/null || die "popd failed"
1663
1664 # This is per bug #390691, without the duplication refactor, and with
1665 # the 3-way structure per comment #6. This enable users with old
1666 # coreutils to upgrade a lot easier (you need to upgrade python+portage
1667 # before coreutils can be upgraded).
1668 if ROOT="/" has_version '>=sys-apps/coreutils-6.9.90'; then
1669 cp -fr --preserve=all --no-preserve=context "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1670 elif ROOT="/" has_version sys-apps/coreutils; then
1671 cp -fr --preserve=all "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1672 else
1673 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1674 fi
1675 done
1676
1677 rm -fr "${intermediate_installation_images_directory}"
1678
1679 if [[ "${#wrapper_scripts[@]}" -ge 1 ]]; then
1680 rm -f "${T}/python_wrapper_scripts"
1681
1682 for file in "${wrapper_scripts[@]}"; do
1683 echo -n "${file}" >> "${T}/python_wrapper_scripts"
1684 echo -en "\x00" >> "${T}/python_wrapper_scripts"
1685 done
1686
1687 while read -d $'\0' -r file; do
1688 wrapper_scripts_set+=("${file}")
1689 done < <("$(PYTHON -f)" -c \
1690"import sys
1691
1692if hasattr(sys.stdout, 'buffer'):
1693 # Python 3
1694 stdout = sys.stdout.buffer
1695else:
1696 # Python 2
1697 stdout = sys.stdout
1698
1699python_wrapper_scripts_file = open('${T}/python_wrapper_scripts', 'rb')
1700files = set(python_wrapper_scripts_file.read().rstrip(${b}'\x00').split(${b}'\x00'))
1701python_wrapper_scripts_file.close()
1702
1703for file in sorted(files):
1704 stdout.write(file)
1705 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of set of wrapper scripts")
1706
1707 python_generate_wrapper_scripts $([[ "${quiet}" == "1" ]] && echo --quiet) "${wrapper_scripts_set[@]}"
1708 fi
1709}
1710
890# ================================================================================================ 1711# ================================================================================================
891# ====== FUNCTIONS FOR PACKAGES NOT SUPPORTING INSTALLATION FOR MULTIPLE VERSIONS OF PYTHON ====== 1712# ========= FUNCTIONS FOR PACKAGES NOT SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ==========
892# ================================================================================================ 1713# ================================================================================================
1714
1715unset EPYTHON PYTHON_ABI
893 1716
894# @FUNCTION: python_set_active_version 1717# @FUNCTION: python_set_active_version
895# @USAGE: <Python_ABI|2|3> 1718# @USAGE: <Python_ABI|2|3>
896# @DESCRIPTION: 1719# @DESCRIPTION:
897# Set active version of Python. 1720# Set locally active version of Python.
1721# If Python_ABI argument is specified, then version of Python corresponding to Python_ABI is used.
1722# If 2 argument is specified, then active version of CPython 2 is used.
1723# If 3 argument is specified, then active version of CPython 3 is used.
1724#
1725# This function can be used only in pkg_setup() phase.
898python_set_active_version() { 1726python_set_active_version() {
1727 if [[ "${EBUILD_PHASE}" != "setup" ]]; then
1728 die "${FUNCNAME}() can be used only in pkg_setup() phase"
1729 fi
1730
1731 if _python_package_supporting_installation_for_multiple_python_abis; then
1732 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1733 fi
1734
899 if [[ "$#" -ne 1 ]]; then 1735 if [[ "$#" -ne 1 ]]; then
900 die "${FUNCNAME}() requires 1 argument" 1736 die "${FUNCNAME}() requires 1 argument"
901 fi 1737 fi
902 1738
903 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then 1739 _python_initial_sanity_checks
904 if ! _python_implementation && ! has_version "dev-lang/python:$1"; then 1740
905 die "${FUNCNAME}(): 'dev-lang/python:$1' is not installed" 1741 if [[ -z "${PYTHON_ABI}" ]]; then
1742 if [[ -n "$(_python_get_implementation --ignore-invalid "$1")" ]]; then
1743 # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses,
1744 # so it does not need to be exported to subprocesses.
1745 PYTHON_ABI="$1"
1746 if ! _python_implementation && ! has_version "$(python_get_implementational_package)"; then
1747 die "${FUNCNAME}(): '$(python_get_implementational_package)' is not installed"
906 fi 1748 fi
907 export EPYTHON="$(PYTHON "$1")" 1749 export EPYTHON="$(PYTHON "$1")"
908 elif [[ "$1" == "2" ]]; then 1750 elif [[ "$1" == "2" ]]; then
909 if ! _python_implementation && ! has_version "=dev-lang/python-2*"; then 1751 if ! _python_implementation && ! has_version "=dev-lang/python-2*"; then
910 die "${FUNCNAME}(): '=dev-lang/python-2*' is not installed" 1752 die "${FUNCNAME}(): '=dev-lang/python-2*' is not installed"
911 fi 1753 fi
912 export EPYTHON="$(PYTHON -2)" 1754 export EPYTHON="$(PYTHON -2)"
1755 PYTHON_ABI="${EPYTHON#python}"
1756 PYTHON_ABI="${PYTHON_ABI%%-*}"
913 elif [[ "$1" == "3" ]]; then 1757 elif [[ "$1" == "3" ]]; then
914 if ! _python_implementation && ! has_version "=dev-lang/python-3*"; then 1758 if ! _python_implementation && ! has_version "=dev-lang/python-3*"; then
915 die "${FUNCNAME}(): '=dev-lang/python-3*' is not installed" 1759 die "${FUNCNAME}(): '=dev-lang/python-3*' is not installed"
916 fi 1760 fi
917 export EPYTHON="$(PYTHON -3)" 1761 export EPYTHON="$(PYTHON -3)"
1762 PYTHON_ABI="${EPYTHON#python}"
1763 PYTHON_ABI="${PYTHON_ABI%%-*}"
918 else 1764 else
919 die "${FUNCNAME}(): Unrecognized argument '$1'" 1765 die "${FUNCNAME}(): Unrecognized argument '$1'"
920 fi 1766 fi
1767 fi
921 1768
922 # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses, 1769 _python_final_sanity_checks
923 # so it does not need to be exported to subprocesses.
924 PYTHON_ABI="${EPYTHON#python}"
925 PYTHON_ABI="${PYTHON_ABI%%-*}"
926 1770
927 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable. 1771 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable.
928 PYTHON_REQUESTED_ACTIVE_VERSION="$1" 1772 PYTHON_REQUESTED_ACTIVE_VERSION="$1"
929} 1773}
930 1774
931# @FUNCTION: python_need_rebuild 1775# @FUNCTION: python_need_rebuild
932# @DESCRIPTION: Run without arguments, specifies that the package should be 1776# @DESCRIPTION:
933# rebuilt after a python upgrade. 1777# Mark current package for rebuilding by python-updater after
934# Do not use this function in ebuilds of packages supporting installation 1778# switching of active version of Python.
935# for multiple versions of Python.
936python_need_rebuild() { 1779python_need_rebuild() {
1780 if _python_package_supporting_installation_for_multiple_python_abis; then
1781 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1782 fi
1783
1784 _python_check_python_pkg_setup_execution
1785
1786 if [[ "$#" -ne 0 ]]; then
1787 die "${FUNCNAME}() does not accept arguments"
1788 fi
1789
937 export PYTHON_NEED_REBUILD="$(PYTHON -A --ABI)" 1790 export PYTHON_NEED_REBUILD="$(PYTHON --ABI)"
938} 1791}
939 1792
940# ================================================================================================ 1793# ================================================================================================
941# ======================================= GETTER FUNCTIONS ======================================= 1794# ======================================= GETTER FUNCTIONS =======================================
942# ================================================================================================ 1795# ================================================================================================
943 1796
1797_PYTHON_ABI_EXTRACTION_COMMAND=\
1798'import platform
1799import sys
1800sys.stdout.write(".".join(str(x) for x in sys.version_info[:2]))
1801if platform.system()[:4] == "Java":
1802 sys.stdout.write("-jython")
1803elif hasattr(platform, "python_implementation") and platform.python_implementation() == "PyPy":
1804 sys.stdout.write("-pypy-" + ".".join(str(x) for x in sys.pypy_version_info[:2]))'
1805
1806_python_get_implementation() {
1807 local ignore_invalid="0"
1808
1809 while (($#)); do
1810 case "$1" in
1811 --ignore-invalid)
1812 ignore_invalid="1"
1813 ;;
1814 --)
1815 shift
1816 break
1817 ;;
1818 -*)
1819 die "${FUNCNAME}(): Unrecognized option '$1'"
1820 ;;
1821 *)
1822 break
1823 ;;
1824 esac
1825 shift
1826 done
1827
1828 if [[ "$#" -ne 1 ]]; then
1829 die "${FUNCNAME}() requires 1 argument"
1830 fi
1831
1832 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
1833 echo "CPython"
1834 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
1835 echo "Jython"
1836 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-pypy-[[:digit:]]+\.[[:digit:]]+$ ]]; then
1837 echo "PyPy"
1838 else
1839 if [[ "${ignore_invalid}" == "0" ]]; then
1840 die "${FUNCNAME}(): Unrecognized Python ABI '$1'"
1841 fi
1842 fi
1843}
1844
944# @FUNCTION: PYTHON 1845# @FUNCTION: PYTHON
945# @USAGE: [-2] [-3] [--ABI] [-A|--active] [-a|--absolute-path] [-f|--final-ABI] [--] <Python_ABI="${PYTHON_ABI}"> 1846# @USAGE: [-2] [-3] [--ABI] [-a|--absolute-path] [-f|--final-ABI] [--] <Python_ABI="${PYTHON_ABI}">
946# @DESCRIPTION: 1847# @DESCRIPTION:
947# Print Python interpreter filename for specified Python ABI. If Python_ABI argument 1848# Print filename of Python interpreter for specified Python ABI. If Python_ABI argument
948# is ommitted, then PYTHON_ABI environment variable must be set and is used. 1849# is ommitted, then PYTHON_ABI environment variable must be set and is used.
949# If -2 option is specified, then active version of Python 2 is used. 1850# If -2 option is specified, then active version of CPython 2 is used.
950# If -3 option is specified, then active version of Python 3 is used. 1851# If -3 option is specified, then active version of CPython 3 is used.
951# If --active option is specified, then active version of Python is used.
952# Active version of Python can be set by python_set_active_version().
953# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1852# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
954# -2, -3, --active and --final-ABI options and Python_ABI argument cannot be specified simultaneously. 1853# -2, -3 and --final-ABI options and Python_ABI argument cannot be specified simultaneously.
955# If --ABI option is specified, then only specified Python ABI is printed instead of 1854# If --ABI option is specified, then only specified Python ABI is printed instead of
956# Python interpreter filename. 1855# filename of Python interpreter.
1856# If --absolute-path option is specified, then absolute path to Python interpreter is printed.
957# --ABI and --absolute-path options cannot be specified simultaneously. 1857# --ABI and --absolute-path options cannot be specified simultaneously.
958PYTHON() { 1858PYTHON() {
959 local ABI_output="0" absolute_path_output="0" active="0" final_ABI="0" python2="0" python3="0" slot= 1859 _python_check_python_pkg_setup_execution
1860
1861 local ABI_output="0" absolute_path_output="0" final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" python_interpreter python2="0" python3="0"
960 1862
961 while (($#)); do 1863 while (($#)); do
962 case "$1" in 1864 case "$1" in
963 -2) 1865 -2)
964 python2="1" 1866 python2="1"
967 python3="1" 1869 python3="1"
968 ;; 1870 ;;
969 --ABI) 1871 --ABI)
970 ABI_output="1" 1872 ABI_output="1"
971 ;; 1873 ;;
972 -A|--active)
973 active="1"
974 ;;
975 -a|--absolute-path) 1874 -a|--absolute-path)
976 absolute_path_output="1" 1875 absolute_path_output="1"
977 ;; 1876 ;;
978 -f|--final-ABI) 1877 -f|--final-ABI)
979 final_ABI="1" 1878 final_ABI="1"
991 esac 1890 esac
992 shift 1891 shift
993 done 1892 done
994 1893
995 if [[ "${ABI_output}" == "1" && "${absolute_path_output}" == "1" ]]; then 1894 if [[ "${ABI_output}" == "1" && "${absolute_path_output}" == "1" ]]; then
996 die "${FUNCNAME}(): '--ABI and '--absolute-path' options cannot be specified simultaneously" 1895 die "${FUNCNAME}(): '--ABI' and '--absolute-path' options cannot be specified simultaneously"
997 fi 1896 fi
998 1897
999 if [[ "$((${python2} + ${python3} + ${active} + ${final_ABI}))" -gt 1 ]]; then 1898 if [[ "$((${python2} + ${python3} + ${final_ABI}))" -gt 1 ]]; then
1000 die "${FUNCNAME}(): '-2', '-3', '--active' or '--final-ABI' options cannot be specified simultaneously" 1899 die "${FUNCNAME}(): '-2', '-3' or '--final-ABI' options cannot be specified simultaneously"
1001 fi 1900 fi
1002 1901
1003 if [[ "$#" -eq 0 ]]; then 1902 if [[ "$#" -eq 0 ]]; then
1004 if [[ "${active}" == "1" ]]; then
1005 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
1006 die "${FUNCNAME}(): '--active' option cannot be used in ebuilds of packages supporting installation for multiple versions of Python"
1007 fi
1008 slot="$("${EPREFIX}/usr/bin/python" -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')"
1009 elif [[ "${final_ABI}" == "1" ]]; then 1903 if [[ "${final_ABI}" == "1" ]]; then
1010 if has "${EAPI:-0}" 0 1 2 3 4 && [[ -z "${SUPPORT_PYTHON_ABIS}" ]]; then 1904 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1011 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple versions of Python" 1905 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1012 fi 1906 fi
1013 validate_PYTHON_ABIS 1907 _python_calculate_PYTHON_ABIS
1014 slot="${PYTHON_ABIS##* }" 1908 PYTHON_ABI="${PYTHON_ABIS##* }"
1015 elif [[ "${python2}" == "1" ]]; then 1909 elif [[ "${python2}" == "1" ]]; then
1016 slot="$(eselect python show --python2)" 1910 PYTHON_ABI="$(ROOT="/" eselect python show --python2 --ABI)"
1017 if [[ -z "${slot}" ]]; then 1911 if [[ -z "${PYTHON_ABI}" ]]; then
1018 die "${FUNCNAME}(): Active Python 2 interpreter not set" 1912 die "${FUNCNAME}(): Active version of CPython 2 not set"
1019 elif [[ "${slot}" != "python2."* ]]; then 1913 elif [[ "${PYTHON_ABI}" != "2."* ]]; then
1020 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`" 1914 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`"
1021 fi 1915 fi
1022 slot="${slot#python}"
1023 elif [[ "${python3}" == "1" ]]; then 1916 elif [[ "${python3}" == "1" ]]; then
1024 slot="$(eselect python show --python3)" 1917 PYTHON_ABI="$(ROOT="/" eselect python show --python3 --ABI)"
1025 if [[ -z "${slot}" ]]; then 1918 if [[ -z "${PYTHON_ABI}" ]]; then
1026 die "${FUNCNAME}(): Active Python 3 interpreter not set" 1919 die "${FUNCNAME}(): Active version of CPython 3 not set"
1027 elif [[ "${slot}" != "python3."* ]]; then 1920 elif [[ "${PYTHON_ABI}" != "3."* ]]; then
1028 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`" 1921 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`"
1029 fi 1922 fi
1030 slot="${slot#python}" 1923 elif _python_package_supporting_installation_for_multiple_python_abis; then
1031 elif [[ -n "${PYTHON_ABI}" ]]; then 1924 if ! _python_abi-specific_local_scope; then
1032 slot="${PYTHON_ABI}" 1925 die "${FUNCNAME}() should be used in ABI-specific local scope"
1926 fi
1033 else 1927 else
1034 die "${FUNCNAME}(): Invalid usage" 1928 PYTHON_ABI="$("${EPREFIX}/usr/bin/python" -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")"
1929 if [[ -z "${PYTHON_ABI}" ]]; then
1930 die "${FUNCNAME}(): Failure of extraction of locally active version of Python"
1931 fi
1035 fi 1932 fi
1036 elif [[ "$#" -eq 1 ]]; then 1933 elif [[ "$#" -eq 1 ]]; then
1037 if [[ "${active}" == "1" ]]; then
1038 die "${FUNCNAME}(): '--active' option and Python ABI cannot be specified simultaneously"
1039 fi
1040 if [[ "${final_ABI}" == "1" ]]; then 1934 if [[ "${final_ABI}" == "1" ]]; then
1041 die "${FUNCNAME}(): '--final-ABI' option and Python ABI cannot be specified simultaneously" 1935 die "${FUNCNAME}(): '--final-ABI' option and Python ABI cannot be specified simultaneously"
1042 fi 1936 fi
1043 if [[ "${python2}" == "1" ]]; then 1937 if [[ "${python2}" == "1" ]]; then
1044 die "${FUNCNAME}(): '-2' option and Python ABI cannot be specified simultaneously" 1938 die "${FUNCNAME}(): '-2' option and Python ABI cannot be specified simultaneously"
1045 fi 1939 fi
1046 if [[ "${python3}" == "1" ]]; then 1940 if [[ "${python3}" == "1" ]]; then
1047 die "${FUNCNAME}(): '-3' option and Python ABI cannot be specified simultaneously" 1941 die "${FUNCNAME}(): '-3' option and Python ABI cannot be specified simultaneously"
1048 fi 1942 fi
1049 slot="$1" 1943 PYTHON_ABI="$1"
1050 else 1944 else
1051 die "${FUNCNAME}(): Invalid usage" 1945 die "${FUNCNAME}(): Invalid usage"
1052 fi 1946 fi
1053 1947
1054 if [[ "${ABI_output}" == "1" ]]; then 1948 if [[ "${ABI_output}" == "1" ]]; then
1055 echo -n "${slot}" 1949 echo -n "${PYTHON_ABI}"
1056 return 1950 return
1951 else
1952 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1953 python_interpreter="python${PYTHON_ABI}"
1954 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1955 python_interpreter="jython${PYTHON_ABI%-jython}"
1956 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
1957 python_interpreter="pypy-c${PYTHON_ABI#*-pypy-}"
1958 fi
1959
1057 elif [[ "${absolute_path_output}" == "1" ]]; then 1960 if [[ "${absolute_path_output}" == "1" ]]; then
1058 echo -n "${EPREFIX}/usr/bin/python${slot}" 1961 echo -n "${EPREFIX}/usr/bin/${python_interpreter}"
1059 else 1962 else
1060 echo -n "python${slot}" 1963 echo -n "${python_interpreter}"
1964 fi
1061 fi 1965 fi
1062 1966
1063 if [[ -n "${ABI}" && "${ABI}" != "${DEFAULT_ABI}" && "${DEFAULT_ABI}" != "default" ]]; then 1967 if [[ -n "${ABI}" && "${ABI}" != "${DEFAULT_ABI}" && "${DEFAULT_ABI}" != "default" ]]; then
1064 echo -n "-${ABI}" 1968 echo -n "-${ABI}"
1065 fi 1969 fi
1066} 1970}
1067 1971
1068# @FUNCTION: python_get_includedir 1972# @FUNCTION: python_get_implementation
1069# @USAGE: [-f|--final-ABI] 1973# @USAGE: [-f|--final-ABI]
1070# @DESCRIPTION: 1974# @DESCRIPTION:
1071# Print path to Python include directory. 1975# Print name of Python implementation.
1072# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1976# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1073python_get_includedir() { 1977python_get_implementation() {
1074 local final_ABI="0" 1978 _python_check_python_pkg_setup_execution
1979
1980 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1075 1981
1076 while (($#)); do 1982 while (($#)); do
1077 case "$1" in 1983 case "$1" in
1078 -f|--final-ABI) 1984 -f|--final-ABI)
1079 final_ABI="1" 1985 final_ABI="1"
1087 esac 1993 esac
1088 shift 1994 shift
1089 done 1995 done
1090 1996
1091 if [[ "${final_ABI}" == "1" ]]; then 1997 if [[ "${final_ABI}" == "1" ]]; then
1092 echo "/usr/include/python$(PYTHON -f --ABI)" 1998 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1093 elif [[ -n "${PYTHON_ABI}" ]]; then 1999 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1094 echo "/usr/include/python${PYTHON_ABI}" 2000 fi
2001 PYTHON_ABI="$(PYTHON -f --ABI)"
2002 else
2003 if _python_package_supporting_installation_for_multiple_python_abis; then
2004 if ! _python_abi-specific_local_scope; then
2005 die "${FUNCNAME}() should be used in ABI-specific local scope"
2006 fi
1095 else 2007 else
1096 echo "/usr/include/python$(PYTHON -A --ABI)" 2008 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1097 fi 2009 fi
1098} 2010 fi
1099 2011
1100# @FUNCTION: python_get_libdir 2012 echo "$(_python_get_implementation "${PYTHON_ABI}")"
2013}
2014
2015# @FUNCTION: python_get_implementational_package
1101# @USAGE: [-f|--final-ABI] 2016# @USAGE: [-f|--final-ABI]
1102# @DESCRIPTION: 2017# @DESCRIPTION:
1103# Print path to Python library directory. 2018# Print category, name and slot of package providing Python implementation.
1104# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2019# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1105python_get_libdir() { 2020python_get_implementational_package() {
1106 local final_ABI="0" 2021 _python_check_python_pkg_setup_execution
2022
2023 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1107 2024
1108 while (($#)); do 2025 while (($#)); do
1109 case "$1" in 2026 case "$1" in
1110 -f|--final-ABI) 2027 -f|--final-ABI)
1111 final_ABI="1" 2028 final_ABI="1"
1119 esac 2036 esac
1120 shift 2037 shift
1121 done 2038 done
1122 2039
1123 if [[ "${final_ABI}" == "1" ]]; then 2040 if [[ "${final_ABI}" == "1" ]]; then
1124 echo "/usr/$(get_libdir)/python$(PYTHON -f --ABI)" 2041 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1125 elif [[ -n "${PYTHON_ABI}" ]]; then 2042 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1126 echo "/usr/$(get_libdir)/python${PYTHON_ABI}" 2043 fi
2044 PYTHON_ABI="$(PYTHON -f --ABI)"
2045 else
2046 if _python_package_supporting_installation_for_multiple_python_abis; then
2047 if ! _python_abi-specific_local_scope; then
2048 die "${FUNCNAME}() should be used in ABI-specific local scope"
2049 fi
1127 else 2050 else
2051 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2052 fi
2053 fi
2054
2055 if [[ "${EAPI:-0}" == "0" ]]; then
2056 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2057 echo "=dev-lang/python-${PYTHON_ABI}*"
2058 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2059 echo "=dev-java/jython-${PYTHON_ABI%-jython}*"
2060 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2061 echo "=dev-python/pypy-${PYTHON_ABI#*-pypy-}*"
2062 fi
2063 else
2064 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2065 echo "dev-lang/python:${PYTHON_ABI}"
2066 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2067 echo "dev-java/jython:${PYTHON_ABI%-jython}"
2068 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2069 echo "dev-python/pypy:${PYTHON_ABI#*-pypy-}"
2070 fi
2071 fi
2072}
2073
2074# @FUNCTION: python_get_includedir
2075# @USAGE: [-b|--base-path] [-f|--final-ABI]
2076# @DESCRIPTION:
2077# Print path to Python include directory.
2078# If --base-path option is specified, then path not prefixed with "/" is printed.
2079# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2080python_get_includedir() {
2081 _python_check_python_pkg_setup_execution
2082
2083 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
2084
2085 while (($#)); do
2086 case "$1" in
2087 -b|--base-path)
2088 base_path="1"
2089 ;;
2090 -f|--final-ABI)
2091 final_ABI="1"
2092 ;;
2093 -*)
2094 die "${FUNCNAME}(): Unrecognized option '$1'"
2095 ;;
2096 *)
2097 die "${FUNCNAME}(): Invalid usage"
2098 ;;
2099 esac
2100 shift
2101 done
2102
2103 if [[ "${base_path}" == "0" ]]; then
2104 prefix="/"
2105 fi
2106
2107 if [[ "${final_ABI}" == "1" ]]; then
2108 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2109 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2110 fi
2111 PYTHON_ABI="$(PYTHON -f --ABI)"
2112 else
2113 if _python_package_supporting_installation_for_multiple_python_abis; then
2114 if ! _python_abi-specific_local_scope; then
2115 die "${FUNCNAME}() should be used in ABI-specific local scope"
2116 fi
2117 else
2118 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2119 fi
2120 fi
2121
2122 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2123 echo "${prefix}usr/include/python${PYTHON_ABI}"
2124 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2125 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Include"
2126 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2127 echo "${prefix}usr/$(get_libdir)/pypy${PYTHON_ABI#*-pypy-}/include"
2128 fi
2129}
2130
2131# @FUNCTION: python_get_libdir
2132# @USAGE: [-b|--base-path] [-f|--final-ABI]
2133# @DESCRIPTION:
2134# Print path to Python standard library directory.
2135# If --base-path option is specified, then path not prefixed with "/" is printed.
2136# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2137python_get_libdir() {
2138 _python_check_python_pkg_setup_execution
2139
2140 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
2141
2142 while (($#)); do
2143 case "$1" in
2144 -b|--base-path)
2145 base_path="1"
2146 ;;
2147 -f|--final-ABI)
2148 final_ABI="1"
2149 ;;
2150 -*)
2151 die "${FUNCNAME}(): Unrecognized option '$1'"
2152 ;;
2153 *)
2154 die "${FUNCNAME}(): Invalid usage"
2155 ;;
2156 esac
2157 shift
2158 done
2159
2160 if [[ "${base_path}" == "0" ]]; then
2161 prefix="/"
2162 fi
2163
2164 if [[ "${final_ABI}" == "1" ]]; then
2165 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2166 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2167 fi
2168 PYTHON_ABI="$(PYTHON -f --ABI)"
2169 else
2170 if _python_package_supporting_installation_for_multiple_python_abis; then
2171 if ! _python_abi-specific_local_scope; then
2172 die "${FUNCNAME}() should be used in ABI-specific local scope"
2173 fi
2174 else
2175 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2176 fi
2177 fi
2178
2179 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1128 echo "/usr/$(get_libdir)/python$(PYTHON -A --ABI)" 2180 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}"
2181 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2182 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib"
2183 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2184 die "${FUNCNAME}(): PyPy has multiple standard library directories"
1129 fi 2185 fi
1130} 2186}
1131 2187
1132# @FUNCTION: python_get_sitedir 2188# @FUNCTION: python_get_sitedir
1133# @USAGE: [-f|--final-ABI] 2189# @USAGE: [-b|--base-path] [-f|--final-ABI]
1134# @DESCRIPTION: 2190# @DESCRIPTION:
1135# Print path to Python site-packages directory. 2191# Print path to Python site-packages directory.
2192# If --base-path option is specified, then path not prefixed with "/" is printed.
1136# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2193# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1137python_get_sitedir() { 2194python_get_sitedir() {
1138 local options=() 2195 _python_check_python_pkg_setup_execution
2196
2197 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
1139 2198
1140 while (($#)); do 2199 while (($#)); do
1141 case "$1" in 2200 case "$1" in
2201 -b|--base-path)
2202 base_path="1"
2203 ;;
1142 -f|--final-ABI) 2204 -f|--final-ABI)
1143 options+=("$1") 2205 final_ABI="1"
1144 ;; 2206 ;;
1145 -*) 2207 -*)
1146 die "${FUNCNAME}(): Unrecognized option '$1'" 2208 die "${FUNCNAME}(): Unrecognized option '$1'"
1147 ;; 2209 ;;
1148 *) 2210 *)
1150 ;; 2212 ;;
1151 esac 2213 esac
1152 shift 2214 shift
1153 done 2215 done
1154 2216
1155 echo "$(python_get_libdir "${options[@]}")/site-packages" 2217 if [[ "${base_path}" == "0" ]]; then
2218 prefix="/"
2219 fi
2220
2221 if [[ "${final_ABI}" == "1" ]]; then
2222 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2223 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2224 fi
2225 PYTHON_ABI="$(PYTHON -f --ABI)"
2226 else
2227 if _python_package_supporting_installation_for_multiple_python_abis; then
2228 if ! _python_abi-specific_local_scope; then
2229 die "${FUNCNAME}() should be used in ABI-specific local scope"
2230 fi
2231 else
2232 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2233 fi
2234 fi
2235
2236 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2237 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}/site-packages"
2238 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2239 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib/site-packages"
2240 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2241 echo "${prefix}usr/$(get_libdir)/pypy${PYTHON_ABI#*-pypy-}/site-packages"
2242 fi
1156} 2243}
1157 2244
1158# @FUNCTION: python_get_library 2245# @FUNCTION: python_get_library
1159# @USAGE: [-f|--final-ABI] [-l|--linker-option] 2246# @USAGE: [-b|--base-path] [-f|--final-ABI] [-l|--linker-option]
1160# @DESCRIPTION: 2247# @DESCRIPTION:
1161# Print path to Python library. 2248# Print path to Python library.
2249# If --base-path option is specified, then path not prefixed with "/" is printed.
1162# If --linker-option is specified, then "-l${library}" linker option is printed. 2250# If --linker-option is specified, then "-l${library}" linker option is printed.
1163# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2251# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1164python_get_library() { 2252python_get_library() {
1165 local final_ABI="0" linker_option="0" python_version 2253 _python_check_python_pkg_setup_execution
2254
2255 local base_path="0" final_ABI="0" linker_option="0" prefix PYTHON_ABI="${PYTHON_ABI}"
2256
2257 while (($#)); do
2258 case "$1" in
2259 -b|--base-path)
2260 base_path="1"
2261 ;;
2262 -f|--final-ABI)
2263 final_ABI="1"
2264 ;;
2265 -l|--linker-option)
2266 linker_option="1"
2267 ;;
2268 -*)
2269 die "${FUNCNAME}(): Unrecognized option '$1'"
2270 ;;
2271 *)
2272 die "${FUNCNAME}(): Invalid usage"
2273 ;;
2274 esac
2275 shift
2276 done
2277
2278 if [[ "${base_path}" == "0" ]]; then
2279 prefix="/"
2280 fi
2281
2282 if [[ "${base_path}" == "1" && "${linker_option}" == "1" ]]; then
2283 die "${FUNCNAME}(): '--base-path' and '--linker-option' options cannot be specified simultaneously"
2284 fi
2285
2286 if [[ "${final_ABI}" == "1" ]]; then
2287 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2288 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2289 fi
2290 PYTHON_ABI="$(PYTHON -f --ABI)"
2291 else
2292 if _python_package_supporting_installation_for_multiple_python_abis; then
2293 if ! _python_abi-specific_local_scope; then
2294 die "${FUNCNAME}() should be used in ABI-specific local scope"
2295 fi
2296 else
2297 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2298 fi
2299 fi
2300
2301 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2302 if [[ "${linker_option}" == "1" ]]; then
2303 echo "-lpython${PYTHON_ABI}"
2304 else
2305 echo "${prefix}usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)"
2306 fi
2307 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2308 die "${FUNCNAME}(): Jython does not have shared library"
2309 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2310 die "${FUNCNAME}(): PyPy does not have shared library"
2311 fi
2312}
2313
2314# @FUNCTION: python_get_version
2315# @USAGE: [-f|--final-ABI] [-l|--language] [--full] [--major] [--minor] [--micro]
2316# @DESCRIPTION:
2317# Print version of Python implementation.
2318# --full, --major, --minor and --micro options cannot be specified simultaneously.
2319# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed.
2320# If --language option is specified, then version of Python language is printed.
2321# --language and --full options cannot be specified simultaneously.
2322# --language and --micro options cannot be specified simultaneously.
2323# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2324python_get_version() {
2325 _python_check_python_pkg_setup_execution
2326
2327 local final_ABI="0" language="0" language_version full="0" major="0" minor="0" micro="0" PYTHON_ABI="${PYTHON_ABI}" python_command
1166 2328
1167 while (($#)); do 2329 while (($#)); do
1168 case "$1" in 2330 case "$1" in
1169 -f|--final-ABI) 2331 -f|--final-ABI)
1170 final_ABI="1" 2332 final_ABI="1"
1171 ;; 2333 ;;
1172 -l|--linker-option) 2334 -l|--language)
1173 linker_option="1" 2335 language="1"
2336 ;;
2337 --full)
2338 full="1"
2339 ;;
2340 --major)
2341 major="1"
2342 ;;
2343 --minor)
2344 minor="1"
2345 ;;
2346 --micro)
2347 micro="1"
1174 ;; 2348 ;;
1175 -*) 2349 -*)
1176 die "${FUNCNAME}(): Unrecognized option '$1'" 2350 die "${FUNCNAME}(): Unrecognized option '$1'"
1177 ;; 2351 ;;
1178 *) 2352 *)
1181 esac 2355 esac
1182 shift 2356 shift
1183 done 2357 done
1184 2358
1185 if [[ "${final_ABI}" == "1" ]]; then 2359 if [[ "${final_ABI}" == "1" ]]; then
1186 python_version="$(PYTHON -f --ABI)" 2360 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2361 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2362 fi
2363 else
2364 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then
2365 die "${FUNCNAME}() should be used in ABI-specific local scope"
2366 fi
2367 fi
2368
2369 if [[ "$((${full} + ${major} + ${minor} + ${micro}))" -gt 1 ]]; then
2370 die "${FUNCNAME}(): '--full', '--major', '--minor' or '--micro' options cannot be specified simultaneously"
2371 fi
2372
2373 if [[ "${language}" == "1" ]]; then
2374 if [[ "${final_ABI}" == "1" ]]; then
2375 PYTHON_ABI="$(PYTHON -f --ABI)"
1187 elif [[ -n "${PYTHON_ABI}" ]]; then 2376 elif [[ -z "${PYTHON_ABI}" ]]; then
2377 PYTHON_ABI="$(PYTHON --ABI)"
2378 fi
1188 python_version="${PYTHON_ABI}" 2379 language_version="${PYTHON_ABI%%-*}"
2380 if [[ "${full}" == "1" ]]; then
2381 die "${FUNCNAME}(): '--language' and '--full' options cannot be specified simultaneously"
2382 elif [[ "${major}" == "1" ]]; then
2383 echo "${language_version%.*}"
2384 elif [[ "${minor}" == "1" ]]; then
2385 echo "${language_version#*.}"
2386 elif [[ "${micro}" == "1" ]]; then
2387 die "${FUNCNAME}(): '--language' and '--micro' options cannot be specified simultaneously"
1189 else 2388 else
1190 python_version="$(PYTHON -A --ABI)" 2389 echo "${language_version}"
1191 fi 2390 fi
1192 2391 else
2392 if [[ "${full}" == "1" ]]; then
2393 python_command="import sys; print('.'.join(str(x) for x in getattr(sys, 'pypy_version_info', sys.version_info)[:3]))"
2394 elif [[ "${major}" == "1" ]]; then
2395 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[0])"
1193 if [[ "${linker_option}" == "1" ]]; then 2396 elif [[ "${minor}" == "1" ]]; then
1194 echo "-lpython${python_version}" 2397 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[1])"
2398 elif [[ "${micro}" == "1" ]]; then
2399 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[2])"
1195 else 2400 else
1196 echo "/usr/$(get_libdir)/libpython${python_version}$(get_libname)" 2401 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
2402 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2403 echo "${PYTHON_ABI}"
2404 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2405 echo "${PYTHON_ABI%-jython}"
2406 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2407 echo "${PYTHON_ABI#*-pypy-}"
2408 fi
2409 return
2410 fi
2411 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
1197 fi 2412 fi
1198}
1199 2413
2414 if [[ "${final_ABI}" == "1" ]]; then
2415 "$(PYTHON -f)" -c "${python_command}"
2416 else
2417 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}"
2418 fi
2419 fi
2420}
2421
1200# @FUNCTION: python_get_version 2422# @FUNCTION: python_get_implementation_and_version
1201# @USAGE: [-f|--final-ABI] [--major] [--minor] [--micro] 2423# @USAGE: [-f|--final-ABI]
1202# @DESCRIPTION: 2424# @DESCRIPTION:
1203# Print Python version. 2425# Print name and version of Python implementation.
1204# --major, --minor and --micro options cannot be specified simultaneously. 2426# If version of Python implementation is not bound to version of Python language, then
1205# If --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed. 2427# version of Python language is additionally printed.
1206# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2428# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1207python_get_version() { 2429python_get_implementation_and_version() {
1208 local final_ABI="0" major="0" minor="0" micro="0" python_command 2430 _python_check_python_pkg_setup_execution
2431
2432 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1209 2433
1210 while (($#)); do 2434 while (($#)); do
1211 case "$1" in 2435 case "$1" in
1212 -f|--final-ABI) 2436 -f|--final-ABI)
1213 final_ABI="1" 2437 final_ABI="1"
1214 ;; 2438 ;;
1215 --major)
1216 major="1"
1217 ;;
1218 --minor)
1219 minor="1"
1220 ;;
1221 --micro)
1222 micro="1"
1223 ;;
1224 -*) 2439 -*)
1225 die "${FUNCNAME}(): Unrecognized option '$1'" 2440 die "${FUNCNAME}(): Unrecognized option '$1'"
1226 ;; 2441 ;;
1227 *) 2442 *)
1228 die "${FUNCNAME}(): Invalid usage" 2443 die "${FUNCNAME}(): Invalid usage"
1229 ;; 2444 ;;
1230 esac 2445 esac
1231 shift 2446 shift
1232 done 2447 done
1233 2448
1234 if [[ "$((${major} + ${minor} + ${micro}))" -gt 1 ]]; then
1235 die "${FUNCNAME}(): '--major', '--minor' or '--micro' options cannot be specified simultaneously"
1236 fi
1237
1238 if [[ "${major}" == "1" ]]; then
1239 python_command="from sys import version_info; print(version_info[0])"
1240 elif [[ "${minor}" == "1" ]]; then
1241 python_command="from sys import version_info; print(version_info[1])"
1242 elif [[ "${micro}" == "1" ]]; then
1243 python_command="from sys import version_info; print(version_info[2])"
1244 else
1245 python_command="from sys import version_info; print('.'.join([str(x) for x in version_info[:2]]))"
1246 fi
1247
1248 if [[ "${final_ABI}" == "1" ]]; then 2449 if [[ "${final_ABI}" == "1" ]]; then
1249 "$(PYTHON -f)" -c "${python_command}" 2450 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1250 else 2451 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1251 "$(PYTHON "${PYTHON_ABI--A}")" -c "${python_command}"
1252 fi 2452 fi
1253} 2453 PYTHON_ABI="$(PYTHON -f --ABI)"
1254
1255# ================================================================================================
1256# =================================== MISCELLANEOUS FUNCTIONS ====================================
1257# ================================================================================================
1258
1259_python_implementation() {
1260 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
1261 return 0
1262 else
1263 return 1
1264 fi
1265}
1266
1267_python_initialize_prefix_variables() {
1268 if has "${EAPI:-0}" 0 1 2; then
1269 if [[ -n "${ROOT}" && -z "${EROOT}" ]]; then
1270 EROOT="${ROOT%/}${EPREFIX}/"
1271 fi
1272 if [[ -n "${D}" && -z "${ED}" ]]; then
1273 ED="${D%/}${EPREFIX}/"
1274 fi
1275 fi
1276}
1277
1278# @FUNCTION: python_convert_shebangs
1279# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_version> <file|directory> [files|directories]
1280# @DESCRIPTION:
1281# Convert shebangs in specified files. Directories can be specified only with --recursive option.
1282python_convert_shebangs() {
1283 local argument file files=() only_executables="0" python_version quiet="0" recursive="0"
1284
1285 while (($#)); do
1286 case "$1" in
1287 -r|--recursive)
1288 recursive="1"
1289 ;;
1290 -q|--quiet)
1291 quiet="1"
1292 ;;
1293 -x|--only-executables)
1294 only_executables="1"
1295 ;;
1296 --)
1297 shift
1298 break
1299 ;;
1300 -*)
1301 die "${FUNCNAME}(): Unrecognized option '$1'"
1302 ;;
1303 *)
1304 break
1305 ;;
1306 esac
1307 shift
1308 done
1309
1310 if [[ "$#" -eq 0 ]]; then
1311 die "${FUNCNAME}(): Missing Python version and files or directories"
1312 elif [[ "$#" -eq 1 ]]; then
1313 die "${FUNCNAME}(): Missing files or directories"
1314 fi
1315
1316 python_version="$1"
1317 shift
1318
1319 for argument in "$@"; do
1320 if [[ ! -e "${argument}" ]]; then
1321 die "${FUNCNAME}(): '${argument}' does not exist"
1322 elif [[ -f "${argument}" ]]; then
1323 files+=("${argument}")
1324 elif [[ -d "${argument}" ]]; then
1325 if [[ "${recursive}" == "1" ]]; then
1326 if [[ "${only_executables}" == "1" ]]; then
1327 files+=($(find "${argument}" -perm /111 -type f))
1328 else
1329 files+=($(find "${argument}" -type f))
1330 fi
1331 else 2454 else
1332 die "${FUNCNAME}(): '${argument}' is not a regular file" 2455 if _python_package_supporting_installation_for_multiple_python_abis; then
2456 if ! _python_abi-specific_local_scope; then
2457 die "${FUNCNAME}() should be used in ABI-specific local scope"
1333 fi 2458 fi
1334 else 2459 else
1335 die "${FUNCNAME}(): '${argument}' is not a regular file or a directory" 2460 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1336 fi
1337 done
1338
1339 for file in "${files[@]}"; do
1340 file="${file#./}"
1341 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
1342
1343 if [[ "$(head -n1 "${file}")" =~ ^'#!'.*python ]]; then
1344 if [[ "${quiet}" == "0" ]]; then
1345 einfo "Converting shebang in '${file}'"
1346 fi 2461 fi
1347 sed -e "1s/python\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?/python${python_version}/" -i "${file}" || die "Conversion of shebang in '${file}' failed"
1348
1349 # Delete potential whitespace after "#!".
1350 sed -e '1s/\(^#!\)[[:space:]]*/\1/' -i "${file}" || die "sed '${file}' failed"
1351 fi 2462 fi
1352 done
1353}
1354 2463
1355# @FUNCTION: python_mod_exists 2464 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-[[:alnum:]]+-[[:digit:]]+\.[[:digit:]]+$ ]]; then
1356# @USAGE: <module> 2465 echo "$(_python_get_implementation "${PYTHON_ABI}") ${PYTHON_ABI##*-} (Python ${PYTHON_ABI%%-*})"
1357# @DESCRIPTION:
1358# Run with the module name as an argument. It will check if a
1359# Python module is installed and loadable. It will return
1360# TRUE(0) if the module exists, and FALSE(1) if the module does
1361# not exist.
1362#
1363# Example:
1364# if python_mod_exists gtk; then
1365# echo "gtk support enabled"
1366# fi
1367python_mod_exists() {
1368 if [[ "$#" -ne 1 ]]; then
1369 die "${FUNCNAME}() requires 1 argument"
1370 fi
1371 "$(PYTHON "${PYTHON_ABI--A}")" -c "import $1" &> /dev/null
1372}
1373
1374# @FUNCTION: python_tkinter_exists
1375# @DESCRIPTION:
1376# Run without arguments, checks if Python was compiled with Tkinter
1377# support. If not, prints an error message and dies.
1378python_tkinter_exists() {
1379 if ! "$(PYTHON "${PYTHON_ABI--A}")" -c "from sys import version_info
1380if version_info[0] == 3:
1381 import tkinter
1382else: 2466 else
1383 import Tkinter" &> /dev/null; then 2467 echo "$(_python_get_implementation "${PYTHON_ABI}") ${PYTHON_ABI%%-*}"
1384 eerror "Python needs to be rebuilt with tkinter support enabled."
1385 eerror "Add the following line to '${EPREFIX}/etc/portage/package.use' and rebuild Python"
1386 eerror "dev-lang/python tk"
1387 die "Python installed without support for tkinter"
1388 fi 2468 fi
1389} 2469}
1390 2470
1391# ================================================================================================ 2471# ================================================================================================
1392# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================ 2472# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================
1396# @DESCRIPTION: 2476# @DESCRIPTION:
1397# User-configurable verbosity of tests of Python modules. 2477# User-configurable verbosity of tests of Python modules.
1398# Supported values: 0, 1, 2, 3, 4. 2478# Supported values: 0, 1, 2, 3, 4.
1399PYTHON_TEST_VERBOSITY="${PYTHON_TEST_VERBOSITY:-1}" 2479PYTHON_TEST_VERBOSITY="${PYTHON_TEST_VERBOSITY:-1}"
1400 2480
2481_python_test_hook() {
2482 if [[ "$#" -ne 1 ]]; then
2483 die "${FUNCNAME}() requires 1 argument"
2484 fi
2485
2486 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${_PYTHON_TEST_FUNCTION}_$1_hook")" == "function" ]]; then
2487 "${_PYTHON_TEST_FUNCTION}_$1_hook"
2488 fi
2489}
2490
1401# @FUNCTION: python_execute_nosetests 2491# @FUNCTION: python_execute_nosetests
1402# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments] 2492# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
1403# @DESCRIPTION: 2493# @DESCRIPTION:
1404# Execute nosetests for all enabled versions of Python. 2494# Execute nosetests for all enabled Python ABIs.
2495# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
2496# python_execute_nosetests_pre_hook() and python_execute_nosetests_post_hook(), if they are defined.
1405python_execute_nosetests() { 2497python_execute_nosetests() {
2498 _python_check_python_pkg_setup_execution
2499 _python_set_color_variables
2500
1406 local PYTHONPATH_template= separate_build_dirs= 2501 local PYTHONPATH_template separate_build_dirs
1407 2502
1408 while (($#)); do 2503 while (($#)); do
1409 case "$1" in 2504 case "$1" in
1410 -P|--PYTHONPATH) 2505 -P|--PYTHONPATH)
1411 PYTHONPATH_template="$2" 2506 PYTHONPATH_template="$2"
1427 esac 2522 esac
1428 shift 2523 shift
1429 done 2524 done
1430 2525
1431 python_test_function() { 2526 python_test_function() {
1432 local evaluated_PYTHONPATH= 2527 local evaluated_PYTHONPATH
1433 2528
1434 if [[ -n "${PYTHONPATH_template}" ]]; then
1435 evaluated_PYTHONPATH="$(eval echo -n "${PYTHONPATH_template}")" 2529 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
1436 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then 2530
1437 unset evaluated_PYTHONPATH 2531 _PYTHON_TEST_FUNCTION="python_execute_nosetests" _python_test_hook pre
1438 fi
1439 fi
1440 2532
1441 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2533 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1442 echo PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" 2534 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
1443 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" 2535 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
1444 else 2536 else
1445 echo nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" 2537 echo ${_BOLD}nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
1446 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" 2538 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
1447 fi 2539 fi
2540
2541 _PYTHON_TEST_FUNCTION="python_execute_nosetests" _python_test_hook post
1448 } 2542 }
1449 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 2543 if _python_package_supporting_installation_for_multiple_python_abis; then
1450 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2544 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
1451 else 2545 else
1452 if [[ -n "${separate_build_dirs}" ]]; then 2546 if [[ -n "${separate_build_dirs}" ]]; then
1453 die "${FUNCNAME}(): Invalid usage" 2547 die "${FUNCNAME}(): Invalid usage"
1454 fi 2548 fi
1455 python_test_function "$@" 2549 python_test_function "$@" || die "Testing failed"
1456 fi 2550 fi
2551
2552 unset -f python_test_function
1457} 2553}
1458 2554
1459# @FUNCTION: python_execute_py.test 2555# @FUNCTION: python_execute_py.test
1460# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments] 2556# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
1461# @DESCRIPTION: 2557# @DESCRIPTION:
1462# Execute py.test for all enabled versions of Python. 2558# Execute py.test for all enabled Python ABIs.
2559# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
2560# python_execute_py.test_pre_hook() and python_execute_py.test_post_hook(), if they are defined.
1463python_execute_py.test() { 2561python_execute_py.test() {
2562 _python_check_python_pkg_setup_execution
2563 _python_set_color_variables
2564
1464 local PYTHONPATH_template= separate_build_dirs= 2565 local PYTHONPATH_template separate_build_dirs
1465 2566
1466 while (($#)); do 2567 while (($#)); do
1467 case "$1" in 2568 case "$1" in
1468 -P|--PYTHONPATH) 2569 -P|--PYTHONPATH)
1469 PYTHONPATH_template="$2" 2570 PYTHONPATH_template="$2"
1485 esac 2586 esac
1486 shift 2587 shift
1487 done 2588 done
1488 2589
1489 python_test_function() { 2590 python_test_function() {
1490 local evaluated_PYTHONPATH= 2591 local evaluated_PYTHONPATH
1491 2592
1492 if [[ -n "${PYTHONPATH_template}" ]]; then
1493 evaluated_PYTHONPATH="$(eval echo -n "${PYTHONPATH_template}")" 2593 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
1494 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then 2594
1495 unset evaluated_PYTHONPATH 2595 _PYTHON_TEST_FUNCTION="python_execute_py.test" _python_test_hook pre
1496 fi
1497 fi
1498 2596
1499 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2597 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1500 echo PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" 2598 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL}
1501 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" 2599 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" || return "$?"
1502 else 2600 else
1503 echo py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" 2601 echo ${_BOLD}py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@"${_NORMAL}
1504 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" 2602 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?"
1505 fi 2603 fi
2604
2605 _PYTHON_TEST_FUNCTION="python_execute_py.test" _python_test_hook post
1506 } 2606 }
1507 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 2607 if _python_package_supporting_installation_for_multiple_python_abis; then
1508 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2608 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
1509 else 2609 else
1510 if [[ -n "${separate_build_dirs}" ]]; then 2610 if [[ -n "${separate_build_dirs}" ]]; then
1511 die "${FUNCNAME}(): Invalid usage" 2611 die "${FUNCNAME}(): Invalid usage"
1512 fi 2612 fi
1513 python_test_function "$@" 2613 python_test_function "$@" || die "Testing failed"
1514 fi 2614 fi
2615
2616 unset -f python_test_function
1515} 2617}
1516 2618
1517# @FUNCTION: python_execute_trial 2619# @FUNCTION: python_execute_trial
1518# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments] 2620# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
1519# @DESCRIPTION: 2621# @DESCRIPTION:
1520# Execute trial for all enabled versions of Python. 2622# Execute trial for all enabled Python ABIs.
2623# In ebuilds of packages supporting installation for multiple Python ABIs, this function
2624# calls python_execute_trial_pre_hook() and python_execute_trial_post_hook(), if they are defined.
1521python_execute_trial() { 2625python_execute_trial() {
2626 _python_check_python_pkg_setup_execution
2627 _python_set_color_variables
2628
1522 local PYTHONPATH_template= separate_build_dirs= 2629 local PYTHONPATH_template separate_build_dirs
1523 2630
1524 while (($#)); do 2631 while (($#)); do
1525 case "$1" in 2632 case "$1" in
1526 -P|--PYTHONPATH) 2633 -P|--PYTHONPATH)
1527 PYTHONPATH_template="$2" 2634 PYTHONPATH_template="$2"
1543 esac 2650 esac
1544 shift 2651 shift
1545 done 2652 done
1546 2653
1547 python_test_function() { 2654 python_test_function() {
1548 local evaluated_PYTHONPATH= 2655 local evaluated_PYTHONPATH
1549 2656
1550 if [[ -n "${PYTHONPATH_template}" ]]; then
1551 evaluated_PYTHONPATH="$(eval echo -n "${PYTHONPATH_template}")" 2657 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
1552 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then 2658
1553 unset evaluated_PYTHONPATH 2659 _PYTHON_TEST_FUNCTION="python_execute_trial" _python_test_hook pre
1554 fi
1555 fi
1556 2660
1557 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2661 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1558 echo PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" 2662 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
1559 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" 2663 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
1560 else 2664 else
1561 echo trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" 2665 echo ${_BOLD}trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
1562 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" 2666 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
1563 fi 2667 fi
2668
2669 _PYTHON_TEST_FUNCTION="python_execute_trial" _python_test_hook post
1564 } 2670 }
1565 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 2671 if _python_package_supporting_installation_for_multiple_python_abis; then
1566 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2672 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
1567 else 2673 else
1568 if [[ -n "${separate_build_dirs}" ]]; then 2674 if [[ -n "${separate_build_dirs}" ]]; then
1569 die "${FUNCNAME}(): Invalid usage" 2675 die "${FUNCNAME}(): Invalid usage"
1570 fi 2676 fi
1571 python_test_function "$@" 2677 python_test_function "$@" || die "Testing failed"
1572 fi 2678 fi
2679
2680 unset -f python_test_function
1573} 2681}
1574 2682
1575# ================================================================================================ 2683# ================================================================================================
1576# ======================= FUNCTIONS FOR HANDLING OF BYTE-COMPILED MODULES ======================== 2684# ======================= FUNCTIONS FOR HANDLING OF BYTE-COMPILED MODULES ========================
1577# ================================================================================================ 2685# ================================================================================================
1579# @FUNCTION: python_enable_pyc 2687# @FUNCTION: python_enable_pyc
1580# @DESCRIPTION: 2688# @DESCRIPTION:
1581# Tell Python to automatically recompile modules to .pyc/.pyo if the 2689# Tell Python to automatically recompile modules to .pyc/.pyo if the
1582# timestamps/version stamps have changed. 2690# timestamps/version stamps have changed.
1583python_enable_pyc() { 2691python_enable_pyc() {
2692 _python_check_python_pkg_setup_execution
2693
2694 if [[ "$#" -ne 0 ]]; then
2695 die "${FUNCNAME}() does not accept arguments"
2696 fi
2697
1584 unset PYTHONDONTWRITEBYTECODE 2698 unset PYTHONDONTWRITEBYTECODE
1585} 2699}
1586 2700
1587# @FUNCTION: python_disable_pyc 2701# @FUNCTION: python_disable_pyc
1588# @DESCRIPTION: 2702# @DESCRIPTION:
1589# Tell Python not to automatically recompile modules to .pyc/.pyo 2703# Tell Python not to automatically recompile modules to .pyc/.pyo
1590# even if the timestamps/version stamps do not match. This is done 2704# even if the timestamps/version stamps do not match. This is done
1591# to protect sandbox. 2705# to protect sandbox.
1592python_disable_pyc() { 2706python_disable_pyc() {
2707 _python_check_python_pkg_setup_execution
2708
2709 if [[ "$#" -ne 0 ]]; then
2710 die "${FUNCNAME}() does not accept arguments"
2711 fi
2712
1593 export PYTHONDONTWRITEBYTECODE="1" 2713 export PYTHONDONTWRITEBYTECODE="1"
1594} 2714}
1595 2715
2716_python_clean_compiled_modules() {
2717 _python_initialize_prefix_variables
2718 _python_set_color_variables
2719
2720 [[ "${FUNCNAME[1]}" =~ ^(python_mod_optimize|python_mod_cleanup)$ ]] || die "${FUNCNAME}(): Invalid usage"
2721
2722 local base_module_name compiled_file compiled_files=() dir path py_file root
2723
2724 # Strip trailing slash from EROOT.
2725 root="${EROOT%/}"
2726
2727 for path in "$@"; do
2728 compiled_files=()
2729 if [[ -d "${path}" ]]; then
2730 while read -d $'\0' -r compiled_file; do
2731 compiled_files+=("${compiled_file}")
2732 done < <(find "${path}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -print0)
2733
2734 if [[ "${EBUILD_PHASE}" == "postrm" ]]; then
2735 # Delete empty child directories.
2736 find "${path}" -type d | sort -r | while read -r dir; do
2737 if rmdir "${dir}" 2> /dev/null; then
2738 echo "${_CYAN}<<< ${dir}${_NORMAL}"
2739 fi
2740 done
2741 fi
2742 elif [[ "${path}" == *.py ]]; then
2743 base_module_name="${path##*/}"
2744 base_module_name="${base_module_name%.py}"
2745 if [[ -d "${path%/*}/__pycache__" ]]; then
2746 while read -d $'\0' -r compiled_file; do
2747 compiled_files+=("${compiled_file}")
2748 done < <(find "${path%/*}/__pycache__" "(" -name "${base_module_name}.*.py[co]" -o -name "${base_module_name}\$py.class" ")" -print0)
2749 fi
2750 compiled_files+=("${path}c" "${path}o" "${path%.py}\$py.class")
2751 fi
2752
2753 for compiled_file in "${compiled_files[@]}"; do
2754 [[ ! -f "${compiled_file}" ]] && continue
2755 dir="${compiled_file%/*}"
2756 dir="${dir##*/}"
2757 if [[ "${compiled_file}" == *.py[co] ]]; then
2758 if [[ "${dir}" == "__pycache__" ]]; then
2759 base_module_name="${compiled_file##*/}"
2760 base_module_name="${base_module_name%.*py[co]}"
2761 base_module_name="${base_module_name%.*}"
2762 py_file="${compiled_file%__pycache__/*}${base_module_name}.py"
2763 else
2764 py_file="${compiled_file%[co]}"
2765 fi
2766 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2767 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2768 else
2769 [[ -f "${py_file}" ]] && continue
2770 fi
2771 rm -f "${compiled_file%[co]}"[co]
2772 elif [[ "${compiled_file}" == *\$py.class ]]; then
2773 if [[ "${dir}" == "__pycache__" ]]; then
2774 base_module_name="${compiled_file##*/}"
2775 base_module_name="${base_module_name%\$py.class}"
2776 py_file="${compiled_file%__pycache__/*}${base_module_name}.py"
2777 else
2778 py_file="${compiled_file%\$py.class}.py"
2779 fi
2780 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2781 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2782 else
2783 [[ -f "${py_file}" ]] && continue
2784 fi
2785 rm -f "${compiled_file}"
2786 else
2787 die "${FUNCNAME}(): Unrecognized file type: '${compiled_file}'"
2788 fi
2789
2790 # Delete empty parent directories.
2791 dir="${compiled_file%/*}"
2792 while [[ "${dir}" != "${root}" ]]; do
2793 if ! rmdir "${dir}" 2> /dev/null; then
2794 break
2795 fi
2796 dir="${dir%/*}"
2797 done
2798 done
2799 done
2800}
2801
1596# @FUNCTION: python_mod_optimize 2802# @FUNCTION: python_mod_optimize
1597# @USAGE: [options] [directory|file] 2803# @USAGE: [--allow-evaluated-non-sitedir-paths] [-d directory] [-f] [-l] [-q] [-x regular_expression] [--] <file|directory> [files|directories]
1598# @DESCRIPTION: 2804# @DESCRIPTION:
1599# If no arguments supplied, it will recompile not recursively all modules 2805# Byte-compile specified Python modules.
1600# under sys.path (eg. /usr/lib/python2.6, /usr/lib/python2.6/site-packages). 2806# -d, -f, -l, -q and -x options passed to this function are passed to compileall.py.
1601# 2807#
1602# If supplied with arguments, it will recompile all modules recursively
1603# in the supplied directory.
1604# This function should only be run in pkg_postinst(). 2808# This function can be used only in pkg_postinst() phase.
1605#
1606# Options passed to this function are passed to compileall.py.
1607#
1608# Example:
1609# python_mod_optimize ctypesgencore
1610python_mod_optimize() { 2809python_mod_optimize() {
2810 if [[ "${EBUILD_PHASE}" != "postinst" ]]; then
2811 die "${FUNCNAME}() can be used only in pkg_postinst() phase"
2812 fi
2813
2814 _python_check_python_pkg_setup_execution
1611 _python_initialize_prefix_variables 2815 _python_initialize_prefix_variables
1612 2816
1613 # Check if phase is pkg_postinst(). 2817 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then
1614 [[ ${EBUILD_PHASE} != "postinst" ]] && die "${FUNCNAME}() should only be run in pkg_postinst()" 2818 # PYTHON_ABI variable cannot be local in packages not supporting installation for multiple Python ABIs.
2819 local allow_evaluated_non_sitedir_paths="0" dir dirs=() evaluated_dirs=() evaluated_files=() file files=() iterated_PYTHON_ABIS options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_dirs=() site_packages_files=() stderr stderr_line
1615 2820
2821 if _python_package_supporting_installation_for_multiple_python_abis; then
1616 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 2822 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
1617 local dir file options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" PYTHON_ABI return_code root site_packages_absolute_dirs=() site_packages_dirs=() site_packages_absolute_files=() site_packages_files=() 2823 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
2824 fi
2825 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
2826 else
2827 if has "${EAPI:-0}" 0 1 2 3; then
2828 iterated_PYTHON_ABIS="${PYTHON_ABI:=$(PYTHON --ABI)}"
2829 else
2830 iterated_PYTHON_ABIS="${PYTHON_ABI}"
2831 fi
2832 fi
1618 2833
1619 # Strip trailing slash from ROOT. 2834 # Strip trailing slash from EROOT.
1620 root="${EROOT%/}" 2835 root="${EROOT%/}"
1621 2836
1622 # Respect ROOT and options passed to compileall.py.
1623 while (($#)); do 2837 while (($#)); do
1624 case "$1" in 2838 case "$1" in
2839 --allow-evaluated-non-sitedir-paths)
2840 allow_evaluated_non_sitedir_paths="1"
2841 ;;
1625 -l|-f|-q) 2842 -l|-f|-q)
1626 options+=("$1") 2843 options+=("$1")
1627 ;; 2844 ;;
1628 -d|-x) 2845 -d|-x)
1629 options+=("$1" "$2") 2846 options+=("$1" "$2")
1630 shift 2847 shift
1631 ;; 2848 ;;
2849 --)
2850 shift
2851 break
2852 ;;
1632 -*) 2853 -*)
1633 ewarn "${FUNCNAME}(): Ignoring option '$1'" 2854 die "${FUNCNAME}(): Unrecognized option '$1'"
1634 ;; 2855 ;;
1635 *) 2856 *)
1636 if ! _python_implementation && [[ "$1" =~ ^"${EPREFIX}"/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
1637 die "${FUNCNAME}() does not support absolute paths of directories/files in site-packages directories"
1638 elif [[ "$1" =~ ^/ ]]; then
1639 if [[ -d "${root}/$1" ]]; then
1640 other_dirs+=("${root}/$1")
1641 elif [[ -f "${root}/$1" ]]; then
1642 other_files+=("${root}/$1")
1643 elif [[ -e "${root}/$1" ]]; then
1644 ewarn "'${root}/$1' is not a file or a directory!"
1645 else
1646 ewarn "'${root}/$1' does not exist!"
1647 fi
1648 else
1649 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI-$(PYTHON -A --ABI)}}; do
1650 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then
1651 site_packages_dirs+=("$1")
1652 break 2857 break
1653 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then
1654 site_packages_files+=("$1")
1655 break
1656 elif [[ -e "${root}$(python_get_sitedir)/$1" ]]; then
1657 ewarn "'$1' is not a file or a directory!"
1658 else
1659 ewarn "'$1' does not exist!"
1660 fi
1661 done
1662 fi
1663 ;; 2858 ;;
1664 esac 2859 esac
1665 shift 2860 shift
1666 done 2861 done
1667 2862
2863 if [[ "${allow_evaluated_non_sitedir_paths}" == "1" ]] && ! _python_package_supporting_installation_for_multiple_python_abis; then
2864 die "${FUNCNAME}(): '--allow-evaluated-non-sitedir-paths' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2865 fi
2866
2867 if [[ "$#" -eq 0 ]]; then
2868 die "${FUNCNAME}(): Missing files or directories"
2869 fi
2870
2871 while (($#)); do
2872 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
2873 die "${FUNCNAME}(): Invalid argument '$1'"
2874 elif ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
2875 die "${FUNCNAME}(): Paths of directories / files in site-packages directories must be relative to site-packages directories"
2876 elif [[ "$1" =~ ^/ ]]; then
2877 if _python_package_supporting_installation_for_multiple_python_abis; then
2878 if [[ "${allow_evaluated_non_sitedir_paths}" != "1" ]]; then
2879 die "${FUNCNAME}(): Absolute paths cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
2880 fi
2881 if [[ "$1" != *\$* ]]; then
2882 die "${FUNCNAME}(): '$1' has invalid syntax"
2883 fi
2884 if [[ "$1" == *.py ]]; then
2885 evaluated_files+=("$1")
2886 else
2887 evaluated_dirs+=("$1")
2888 fi
2889 else
2890 if [[ -d "${root}$1" ]]; then
2891 other_dirs+=("${root}$1")
2892 elif [[ -f "${root}$1" ]]; then
2893 other_files+=("${root}$1")
2894 elif [[ -e "${root}$1" ]]; then
2895 eerror "${FUNCNAME}(): '${root}$1' is not a regular file or a directory"
2896 else
2897 eerror "${FUNCNAME}(): '${root}$1' does not exist"
2898 fi
2899 fi
2900 else
2901 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2902 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then
2903 site_packages_dirs+=("$1")
2904 break
2905 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then
2906 site_packages_files+=("$1")
2907 break
2908 elif [[ -e "${root}$(python_get_sitedir)/$1" ]]; then
2909 eerror "${FUNCNAME}(): '$1' is not a regular file or a directory"
2910 else
2911 eerror "${FUNCNAME}(): '$1' does not exist"
2912 fi
2913 done
2914 fi
2915 shift
2916 done
2917
1668 # Set additional options. 2918 # Set additional options.
1669 options+=("-q") 2919 options+=("-q")
1670 2920
1671 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI-$(PYTHON -A --ABI)}}; do 2921 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
1672 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})); then 2922 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})) || ((${#evaluated_dirs[@]})) || ((${#evaluated_files[@]})); then
1673 return_code="0" 2923 return_code="0"
1674 ebegin "Compilation and optimization of Python modules for Python ${PYTHON_ABI}" 2924 stderr=""
1675 if ((${#site_packages_dirs[@]})); then 2925 ebegin "Compilation and optimization of Python modules for $(python_get_implementation_and_version)"
2926 if ((${#site_packages_dirs[@]})) || ((${#evaluated_dirs[@]})); then
1676 for dir in "${site_packages_dirs[@]}"; do 2927 for dir in "${site_packages_dirs[@]}"; do
1677 site_packages_absolute_dirs+=("${root}$(python_get_sitedir)/${dir}") 2928 dirs+=("${root}$(python_get_sitedir)/${dir}")
1678 done 2929 done
1679 "$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" || return_code="1" 2930 for dir in "${evaluated_dirs[@]}"; do
2931 eval "dirs+=(\"\${root}${dir}\")"
2932 done
2933 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m compileall "${options[@]}" "${dirs[@]}" 2>&1)" || return_code="1"
2934 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
1680 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" &> /dev/null || return_code="1" 2935 "$(PYTHON)" -O -m compileall "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1"
1681 fi 2936 fi
1682 if ((${#site_packages_files[@]})); then 2937 _python_clean_compiled_modules "${dirs[@]}"
2938 fi
2939 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then
1683 for file in "${site_packages_files[@]}"; do 2940 for file in "${site_packages_files[@]}"; do
1684 site_packages_absolute_files+=("${root}$(python_get_sitedir)/${file}") 2941 files+=("${root}$(python_get_sitedir)/${file}")
1685 done 2942 done
1686 "$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" || return_code="1" 2943 for file in "${evaluated_files[@]}"; do
1687 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" &> /dev/null || return_code="1" 2944 eval "files+=(\"\${root}${file}\")"
2945 done
2946 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m py_compile "${files[@]}" 2>&1)" || return_code="1"
2947 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2948 "$(PYTHON)" -O -m py_compile "${files[@]}" &> /dev/null || return_code="1"
2949 fi
2950 _python_clean_compiled_modules "${files[@]}"
1688 fi 2951 fi
1689 eend "${return_code}" 2952 eend "${return_code}"
2953 if [[ -n "${stderr}" ]]; then
2954 eerror "Syntax errors / warnings in Python modules for $(python_get_implementation_and_version):" &> /dev/null
2955 while read stderr_line; do
2956 eerror " ${stderr_line}"
2957 done <<< "${stderr}"
1690 fi 2958 fi
1691 unset site_packages_absolute_dirs site_packages_absolute_files 2959 fi
2960 unset dirs files
1692 done 2961 done
1693 2962
2963 if _python_package_supporting_installation_for_multiple_python_abis; then
1694 # Restore previous value of PYTHON_ABI. 2964 # Restore previous value of PYTHON_ABI.
1695 if [[ -n "${previous_PYTHON_ABI}" ]]; then 2965 if [[ -n "${previous_PYTHON_ABI}" ]]; then
1696 PYTHON_ABI="${previous_PYTHON_ABI}" 2966 PYTHON_ABI="${previous_PYTHON_ABI}"
1697 else 2967 else
1698 unset PYTHON_ABI 2968 unset PYTHON_ABI
2969 fi
1699 fi 2970 fi
1700 2971
1701 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then 2972 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then
1702 return_code="0" 2973 return_code="0"
2974 stderr=""
1703 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for Python $(PYTHON -A --ABI)" 2975 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation_and_version)"
1704 if ((${#other_dirs[@]})); then 2976 if ((${#other_dirs[@]})); then
1705 "$(PYTHON "${PYTHON_ABI--A}")" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1" 2977 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m compileall "${options[@]}" "${other_dirs[@]}" 2>&1)" || return_code="1"
2978 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
1706 "$(PYTHON "${PYTHON_ABI--A}")" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1" 2979 "$(PYTHON ${PYTHON_ABI})" -O -m compileall "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1"
2980 fi
2981 _python_clean_compiled_modules "${other_dirs[@]}"
1707 fi 2982 fi
1708 if ((${#other_files[@]})); then 2983 if ((${#other_files[@]})); then
1709 "$(PYTHON "${PYTHON_ABI--A}")" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1" 2984 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m py_compile "${other_files[@]}" 2>&1)" || return_code="1"
2985 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
1710 "$(PYTHON "${PYTHON_ABI--A}")" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1" 2986 "$(PYTHON ${PYTHON_ABI})" -O -m py_compile "${other_files[@]}" &> /dev/null || return_code="1"
2987 fi
2988 _python_clean_compiled_modules "${other_files[@]}"
1711 fi 2989 fi
1712 eend "${return_code}" 2990 eend "${return_code}"
2991 if [[ -n "${stderr}" ]]; then
2992 eerror "Syntax errors / warnings in Python modules placed outside of site-packages directories for $(python_get_implementation_and_version):" &> /dev/null
2993 while read stderr_line; do
2994 eerror " ${stderr_line}"
2995 done <<< "${stderr}"
1713 fi 2996 fi
2997 fi
1714 else 2998 else
2999 # Deprecated part of python_mod_optimize()
3000 ewarn
3001 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
3002 ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-08-01."
3003 ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax."
3004 ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported."
3005 ewarn
3006
1715 local myroot mydirs=() myfiles=() myopts=() return_code="0" 3007 local myroot mydirs=() myfiles=() myopts=() return_code="0"
1716 3008
1717 # strip trailing slash 3009 # strip trailing slash
1718 myroot="${EROOT%/}" 3010 myroot="${EROOT%/}"
1719 3011
1720 # respect ROOT and options passed to compileall.py 3012 # respect EROOT and options passed to compileall.py
1721 while (($#)); do 3013 while (($#)); do
1722 case "$1" in 3014 case "$1" in
1723 -l|-f|-q) 3015 -l|-f|-q)
1724 myopts+=("$1") 3016 myopts+=("$1")
1725 ;; 3017 ;;
1726 -d|-x) 3018 -d|-x)
1727 myopts+=("$1" "$2") 3019 myopts+=("$1" "$2")
1728 shift 3020 shift
1729 ;; 3021 ;;
3022 --)
3023 shift
3024 break
3025 ;;
1730 -*) 3026 -*)
1731 ewarn "${FUNCNAME}(): Ignoring option '$1'" 3027 die "${FUNCNAME}(): Unrecognized option '$1'"
1732 ;; 3028 ;;
1733 *) 3029 *)
1734 if [[ -d "${myroot}"/$1 ]]; then 3030 break
1735 mydirs+=("${myroot}/$1")
1736 elif [[ -f "${myroot}"/$1 ]]; then
1737 # Files are passed to python_mod_compile which is ROOT-aware
1738 myfiles+=("$1")
1739 elif [[ -e "${myroot}/$1" ]]; then
1740 ewarn "${myroot}/$1 is not a file or directory!"
1741 else
1742 ewarn "${myroot}/$1 does not exist!"
1743 fi
1744 ;; 3031 ;;
1745 esac 3032 esac
1746 shift 3033 shift
1747 done 3034 done
1748 3035
3036 if [[ "$#" -eq 0 ]]; then
3037 die "${FUNCNAME}(): Missing files or directories"
3038 fi
3039
3040 while (($#)); do
3041 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
3042 die "${FUNCNAME}(): Invalid argument '$1'"
3043 elif [[ -d "${myroot}/${1#/}" ]]; then
3044 mydirs+=("${myroot}/${1#/}")
3045 elif [[ -f "${myroot}/${1#/}" ]]; then
3046 myfiles+=("${myroot}/${1#/}")
3047 elif [[ -e "${myroot}/${1#/}" ]]; then
3048 eerror "${FUNCNAME}(): ${myroot}/${1#/} is not a regular file or directory"
3049 else
3050 eerror "${FUNCNAME}(): ${myroot}/${1#/} does not exist"
3051 fi
3052 shift
3053 done
3054
1749 # set additional opts 3055 # set additional opts
1750 myopts+=(-q) 3056 myopts+=(-q)
1751 3057
1752 ebegin "Compilation and optimization of Python modules for Python $(PYTHON -A --ABI)" 3058 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
3059
3060 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)"
1753 if ((${#mydirs[@]})); then 3061 if ((${#mydirs[@]})); then
1754 "$(PYTHON "${PYTHON_ABI--A}")" "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" || return_code="1" 3062 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" || return_code="1"
1755 "$(PYTHON "${PYTHON_ABI--A}")" -O "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1" 3063 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1"
3064 _python_clean_compiled_modules "${mydirs[@]}"
1756 fi 3065 fi
1757 3066
1758 if ((${#myfiles[@]})); then 3067 if ((${#myfiles[@]})); then
3068 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" || return_code="1"
3069 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" &> /dev/null || return_code="1"
1759 python_mod_compile "${myfiles[@]}" 3070 _python_clean_compiled_modules "${myfiles[@]}"
1760 fi 3071 fi
1761 3072
1762 eend "${return_code}" 3073 eend "${return_code}"
1763 fi 3074 fi
1764} 3075}
1765 3076
1766# @FUNCTION: python_mod_cleanup 3077# @FUNCTION: python_mod_cleanup
1767# @USAGE: [directory|file] 3078# @USAGE: [--allow-evaluated-non-sitedir-paths] [--] <file|directory> [files|directories]
1768# @DESCRIPTION: 3079# @DESCRIPTION:
1769# Run with optional arguments, where arguments are Python modules. If none given, 3080# Delete orphaned byte-compiled Python modules corresponding to specified Python modules.
1770# it will look in /usr/lib/python[0-9].[0-9].
1771# 3081#
1772# It will recursively scan all compiled Python modules in the directories and
1773# determine if they are orphaned (i.e. their corresponding .py files are missing.)
1774# If they are, then it will remove their corresponding .pyc and .pyo files.
1775#
1776# This function should only be run in pkg_postrm(). 3082# This function can be used only in pkg_postrm() phase.
1777python_mod_cleanup() { 3083python_mod_cleanup() {
3084 if [[ "${EBUILD_PHASE}" != "postrm" ]]; then
3085 die "${FUNCNAME}() can be used only in pkg_postrm() phase"
3086 fi
3087
3088 _python_check_python_pkg_setup_execution
1778 _python_initialize_prefix_variables 3089 _python_initialize_prefix_variables
1779 3090
1780 local path py_file PYTHON_ABI SEARCH_PATH=() root 3091 local allow_evaluated_non_sitedir_paths="0" dir iterated_PYTHON_ABIS PYTHON_ABI="${PYTHON_ABI}" root search_paths=() sitedir
1781 3092
1782 # Check if phase is pkg_postrm(). 3093 if _python_package_supporting_installation_for_multiple_python_abis; then
1783 [[ ${EBUILD_PHASE} != "postrm" ]] && die "${FUNCNAME}() should only be run in pkg_postrm()" 3094 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
3095 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
3096 fi
3097 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
3098 else
3099 if has "${EAPI:-0}" 0 1 2 3; then
3100 iterated_PYTHON_ABIS="${PYTHON_ABI:-$(PYTHON --ABI)}"
3101 else
3102 iterated_PYTHON_ABIS="${PYTHON_ABI}"
3103 fi
3104 fi
1784 3105
1785 # Strip trailing slash from ROOT. 3106 # Strip trailing slash from EROOT.
1786 root="${EROOT%/}" 3107 root="${EROOT%/}"
1787 3108
1788 if (($#)); then 3109 while (($#)); do
1789 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 3110 case "$1" in
3111 --allow-evaluated-non-sitedir-paths)
3112 allow_evaluated_non_sitedir_paths="1"
3113 ;;
3114 --)
3115 shift
3116 break
3117 ;;
3118 -*)
3119 die "${FUNCNAME}(): Unrecognized option '$1'"
3120 ;;
3121 *)
3122 break
3123 ;;
3124 esac
3125 shift
3126 done
3127
3128 if [[ "${allow_evaluated_non_sitedir_paths}" == "1" ]] && ! _python_package_supporting_installation_for_multiple_python_abis; then
3129 die "${FUNCNAME}(): '--allow-evaluated-non-sitedir-paths' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
3130 fi
3131
3132 if [[ "$#" -eq 0 ]]; then
3133 die "${FUNCNAME}(): Missing files or directories"
3134 fi
3135
3136 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then
1790 while (($#)); do 3137 while (($#)); do
3138 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
3139 die "${FUNCNAME}(): Invalid argument '$1'"
1791 if ! _python_implementation && [[ "$1" =~ ^"${EPREFIX}"/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then 3140 elif ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
1792 die "${FUNCNAME}() does not support absolute paths of directories/files in site-packages directories" 3141 die "${FUNCNAME}(): Paths of directories / files in site-packages directories must be relative to site-packages directories"
1793 elif [[ "$1" =~ ^/ ]]; then 3142 elif [[ "$1" =~ ^/ ]]; then
1794 SEARCH_PATH+=("${root}/${1#/}") 3143 if _python_package_supporting_installation_for_multiple_python_abis; then
3144 if [[ "${allow_evaluated_non_sitedir_paths}" != "1" ]]; then
3145 die "${FUNCNAME}(): Absolute paths cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
3146 fi
3147 if [[ "$1" != *\$* ]]; then
3148 die "${FUNCNAME}(): '$1' has invalid syntax"
3149 fi
3150 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
3151 eval "search_paths+=(\"\${root}$1\")"
3152 done
1795 else 3153 else
1796 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI-$(PYTHON -A --ABI)}}; do 3154 search_paths+=("${root}$1")
1797 SEARCH_PATH+=("${root}$(python_get_sitedir)/$1")
1798 done
1799 fi
1800 shift
1801 done
1802 else
1803 SEARCH_PATH=("${@#/}")
1804 SEARCH_PATH=("${SEARCH_PATH[@]/#/${root}/}")
1805 fi
1806 else
1807 local dir sitedir
1808 for dir in "${root}"/usr/lib*; do
1809 if [[ -d "${dir}" && ! -L "${dir}" ]]; then
1810 for sitedir in "${dir}"/python*/site-packages; do
1811 if [[ -d "${sitedir}" ]]; then
1812 SEARCH_PATH+=("${sitedir}")
1813 fi 3155 fi
3156 else
3157 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
3158 search_paths+=("${root}$(python_get_sitedir)/$1")
1814 done 3159 done
1815 fi 3160 fi
3161 shift
1816 done 3162 done
1817 fi
1818
1819 local BLUE CYAN NORMAL
1820 if [[ "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then
1821 BLUE=$'\e[1;34m'
1822 CYAN=$'\e[1;36m'
1823 NORMAL=$'\e[0m'
1824 else 3163 else
1825 BLUE= 3164 # Deprecated part of python_mod_cleanup()
1826 CYAN= 3165 ewarn
1827 NORMAL= 3166 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
1828 fi 3167 ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-08-01."
3168 ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax."
3169 ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported."
3170 ewarn
1829 3171
1830 for path in "${SEARCH_PATH[@]}"; do 3172 search_paths=("${@#/}")
1831 if [[ -d "${path}" ]]; then 3173 search_paths=("${search_paths[@]/#/${root}/}")
1832 find "${path}" -name '*.py[co]' -print0 | while read -rd ''; do
1833 py_file="${REPLY%[co]}"
1834 [[ -f "${py_file}" || (! -f "${py_file}c" && ! -f "${py_file}o") ]] && continue
1835 einfo "${BLUE}<<< ${py_file}[co]${NORMAL}"
1836 rm -f "${py_file}"[co]
1837 done
1838
1839 # Attempt to delete directories, which may be empty.
1840 find "${path}" -type d | sort -r | while read -r dir; do
1841 rmdir "${dir}" 2>/dev/null && einfo "${CYAN}<<< ${dir}${NORMAL}"
1842 done
1843 elif [[ "${path}" == *.py && ! -f "${path}" && (-f "${path}c" || -f "${path}o") ]]; then
1844 einfo "${BLUE}<<< ${path}[co]${NORMAL}"
1845 rm -f "${path}"[co]
1846 fi 3174 fi
1847 done 3175
3176 _python_clean_compiled_modules "${search_paths[@]}"
1848} 3177}
1849 3178
1850# ================================================================================================ 3179# ================================================================================================
1851# ===================================== DEPRECATED FUNCTIONS ===================================== 3180# ===================================== DEPRECATED FUNCTIONS =====================================
1852# ================================================================================================ 3181# ================================================================================================
1853 3182
1854# @FUNCTION: python_version 3183fi # _PYTHON_ECLASS_INHERITED
1855# @DESCRIPTION:
1856# Run without arguments and it will export the version of python
1857# currently in use as $PYVER; sets PYVER/PYVER_MAJOR/PYVER_MINOR
1858python_version() {
1859 if ! has "${EAPI:-0}" 0 1 2; then
1860 eerror "Use PYTHON() and/or python_get_*() instead of python_version()."
1861 die "${FUNCNAME}() cannot be used in this EAPI"
1862 fi
1863
1864 [[ -n "${PYVER}" ]] && return 0
1865 local tmpstr
1866 python="${python:-${EPREFIX}/usr/bin/python}"
1867 tmpstr="$(EPYTHON= ${python} -V 2>&1 )"
1868 export PYVER_ALL="${tmpstr#Python }"
1869 export PYVER_MAJOR="${PYVER_ALL:0:1}"
1870 export PYVER_MINOR="${PYVER_ALL:2:1}"
1871 if [[ "${PYVER_ALL:3:1}" == "." ]]; then
1872 export PYVER_MICRO="${PYVER_ALL:4}"
1873 fi
1874 export PYVER="${PYVER_MAJOR}.${PYVER_MINOR}"
1875}
1876
1877# @FUNCTION: python_mod_compile
1878# @USAGE: <file> [more files ...]
1879# @DESCRIPTION:
1880# Given filenames, it will pre-compile the module's .pyc and .pyo.
1881# This function should only be run in pkg_postinst()
1882#
1883# Example:
1884# python_mod_compile /usr/lib/python2.3/site-packages/pygoogle.py
1885#
1886python_mod_compile() {
1887 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
1888 eerror "Use python_mod_optimize() instead of python_mod_compile()."
1889 die "${FUNCNAME}() cannot be used in this EAPI"
1890 fi
1891
1892 _python_initialize_prefix_variables
1893
1894 local f myroot myfiles=()
1895
1896 # Check if phase is pkg_postinst()
1897 [[ ${EBUILD_PHASE} != postinst ]] && die "${FUNCNAME}() should only be run in pkg_postinst()"
1898
1899 # strip trailing slash
1900 myroot="${EROOT%/}"
1901
1902 # respect ROOT
1903 for f in "$@"; do
1904 [[ -f "${myroot}/${f}" ]] && myfiles+=("${myroot}/${f}")
1905 done
1906
1907 if ((${#myfiles[@]})); then
1908 "$(PYTHON "${PYTHON_ABI--A}")" "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}"
1909 "$(PYTHON "${PYTHON_ABI--A}")" -O "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" &> /dev/null
1910 else
1911 ewarn "No files to compile!"
1912 fi
1913}

Legend:
Removed from v.1.87  
changed lines
  Added in v.1.156

  ViewVC Help
Powered by ViewVC 1.1.20